<?php

namespace Ems\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;

class DependenteRepository {
    /** @var Connection */
    protected $connection;

    public function __construct(
        EntityManager $entityManager
    ) {
        $this->connection = $entityManager->getConnection();
    }

    public function setRelacionaParc(
        array $params
    ): void {
        $sql = <<<SQL
            INSERT INTO RELACIONAPARC (
                NRRELACIONAPARC,    NRORG,                  NRPARCNEGOCIO,
                NRPARCNEGRELAC,     NRTIPORELACIONA,        CDCARGO,
                IDATIVO,            DTINCLUSAO,             DTULTATU,
                NRORGINCLUSAO,      CDOPERINCLUSAO,         NRORGULTATU,
                CDOPERULTATU,       DTFIMRELACIONAMENTO,    NRPARCTESTE
            ) VALUES (
                :NRRELACIONAPARC,   :NRORG,                 :NRPARCNEGOCIO,
                :NRPARCNEGRELAC,    :NRTIPORELACIONA,       :CDCARGO,
                :IDATIVO,           :DTINCLUSAO,            :DTULTATU,
                :NRORGINCLUSAO,     :CDOPERINCLUSAO,        :NRORGULTATU,
                :CDOPERULTATU,      :DTFIMRELACIONAMENTO,   :NRPARCTESTE
            )
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function setDepVinculo(
        array $params
    ): void {
        $sql = <<<SQL
            INSERT INTO FPA_DEPVINCULO (
                NRORG,              NRDEPVINCULO,       NRVINCULOM,
                NRPESSOA,           NROUTRVINCULOM,     NRTIPODEPENDE,
                NREVENTOM,          DTINIDEPENDE,       DTFINDEPENDE,
                IDDEPENDECONTA,     IDEXCDEPENDE,       IDUNIVERSITARIO,
                NREXCEDEPENDE,      DTINIDEPENDEXC,     DTFINDEPENDEXC,
                DTVERCONTROLE,      DTINCLUSAO,         DTULTATU,
                NRORGINCLUSAO,      CDOPERINCLUSAO,     NRORGULTATU,
                CDOPERULTATU
            )
            VALUES (
                :NRORG,             :NRDEPVINCULO,      :NRVINCULOM,
                :NRPESSOA,          :NROUTRVINCULOM,    :NRTIPODEPENDE,
                :NREVENTOM,         :DTINIDEPENDE,      :DTFINDEPENDE,
                :IDDEPENDECONTA,    :IDEXCDEPENDE,      :IDUNIVERSITARIO,
                :NREXCEDEPENDE,     :DTINIDEPENDEXC,    :DTFINDEPENDEXC,
                :DTVERCONTROLE,     :DTINCLUSAO,        :DTULTATU,
                :NRORGINCLUSAO,     :CDOPERINCLUSAO,    :NRORGULTATU,
                :CDOPERULTATU
            )
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}