<?php

namespace HCM\FPA\ObrigacaoLegal\CNAB\Caixa;

use HCM\Util\FPA;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\Util;
use HCM\FPA\Entity\FpaFormcnabEntity;
use HCM\FPA\Entity\FpaCnabmagnetEntity;

class Cnab104 {
    const newLine = '<br>';
    
    private $headerResult;  //Resultados de query, e de dados fixos (formulárionão formatado
    private $headerLoteResult;
    private $bodyResult;
    private $trailerLoteResult;
    private $trailerResult;

    private $headerString      = array(); //String de saída para arquivo txt já formatada
    private $headerLoteString  = array();
    private $bodyString        = array();
    private $trailerLoteString = array();
    private $trailerString     = array();

    private $nrSequencial;  //Sequencial dos registros
    private $vrTotal;       //Soma total dos valores

    private $queryHeader;   //Query's
    private $queryHeaderParams;
    private $queryHeaderLote;
    private $queryHeaderLoteParams;
    private $queryBody;

    private $nrForm;        //Dados do formulário
    private $nrOrg;
    private $nrEvento;
    private $competencia;
    private $tpMovimento;
    private $modalidCalc;
    private $ocorrenCalc;
    private $ordem; //Escopo selecionado. Ordenamento que o dsIni e dsFim deverão considerar
    private $dsIni; //Inicio e fim do escopo selecionado
    private $dsFim;
    private $tpVinculo;
    private $idUtilDtPgtoItem;
    private $idIgnoraOcorrencia;
    private $dtPagamento;
    private $nrEstrutResp;
    private $idLayout;
    //private $nrEstrutura;
    private $idGeraMagnet;
    private $cdBanco;
    private $nsa;
    //private $idTeste;
    private $cdOperador;
    //private $idatualizacad;
    private $cdConvenio;
    private $nmformcnab;

    //Arrays de configuração de layouts
    private $layoutHeader = array( 'CODBANCO' => array( 'tipo' => 'N', 'ini'  =>   1, 'fim'  =>   3 ),   /*CODBANCO 001 003 9(003) 104*/
                                   'CODLOTE'  => array( 'tipo' => 'N', 'ini'  =>   4, 'fim'  =>   7 ),   /*CODLOTE  004 007 9(004) 0000*/
                                   'CODREGIS' => array( 'tipo' => 'N', 'ini'  =>   8, 'fim'  =>   8 ),   /*CODREGIS 008 008 9(001) 0*/
                                   'FILLER1'  => array( 'tipo' => 'A', 'ini'  =>   9, 'fim'  =>  17 ),   /*FILLER1  009 017 X(009) ESPAÇOS*/
                                   'TIPOINCR' => array( 'tipo' => 'N', 'ini'  =>  18, 'fim'  =>  18 ),   /*TIPOINCR 018 018 9(001) 1 = CPF 2 = CNPJ*/
                                   'NROINSCR' => array( 'tipo' => 'N', 'ini'  =>  19, 'fim'  =>  32 ),   /*NROINSCR 019 032 9(014) NOTA 1 INSCRIÇÃO NÚMERO: CNPJ EMPRESA DEBITADA*/
                                   'CODCONVE' => array( 'tipo' => 'N', 'ini'  =>  33, 'fim'  =>  39 ),   /*CODCONVE 033 038 9(006) 039 040 9(002) CÓD. DO CONVÊNIO INFORMADO PELO BANCO  &  PARÂMETRO DE TRANSMISSÃO - CÓD. INFORMADO PELO BANCO*/
                                   'PARAMTRA' => array( 'tipo' => 'N', 'ini'  =>  40, 'fim'  =>  40 ),   /*PARAMTRA 039 040 9(002) PARÂMETRO DE TRANSMISSÃO - CÓD. INFORMADO PELO BANCO*/
                                   'AMBCLIEN' => array( 'tipo' => 'A', 'ini'  =>  41, 'fim'  =>  41 ),   /*AMBCLIEN 041 041 X(001) AMBIENTE CLIENTE - "T" = TESTE / "P"= PRODUÇÃO*/
                                   'AMBCAIXA' => array( 'tipo' => 'A', 'ini'  =>  42, 'fim'  =>  42 ),   /*AMBCAIXA 042 042 X(001) AMBIENTE CAIXA - PREENCHER COM ESPAÇOS*/
                                   'ORIGAPLI' => array( 'tipo' => 'A', 'ini'  =>  43, 'fim'  =>  45 ),   /*ORIGAPLI 043 045 X(003) ORIGEM APLICATIVO - PREENCHER COM ESPAÇOS*/
                                   'NRVERSAO' => array( 'tipo' => 'N', 'ini'  =>  46, 'fim'  =>  49 ),   /*NRVERSAO 046 049 9(004) NÚMERO DE VERSÃO - PREENCHER COM ZEROS*/
                                   'FILLER2'  => array( 'tipo' => 'A', 'ini'  =>  50, 'fim'  =>  52 ),   /*FILLER2  050 052 X(003) FILLER - PREENCHER COM ESPAÇOS*/
                                   'NROAGENC' => array( 'tipo' => 'N', 'ini'  =>  53, 'fim'  =>  58 ),   /*NROAGENC 053 057 9(005) AGÊNCIA DA CONTA CORRENTE - 058 058 9(001) DV DA AGÊNCIA*/
                                   //'DVAGENCI' => array( 'tipo' => 'N', 'ini'  =>  58, 'fim'  =>  58 ),   /*DVAGENCI 058 058 9(001) DV DA AGÊNCIA - PREENCHER DÍGITO VERIFICADOR DA AGÊNCIA DETENTORA DA CONTA CORRENTE DA EMPRESA*/
/*tipo alfa com padding 0*/        'NROCONTA' => array( 'tipo' => 'N', 'ini'  =>  59, 'fim'  =>  71 ),   /*NROCONTA 059 070 9(012) NÚMERO DA CONTA CORRENTE - 071 071 X(001) DV DA CONTA*/
                                   //'DVCONTA'  => array( 'tipo' => 'A', 'ini'  =>  71, 'fim'  =>  71 ),   /*DVCONTA  071 071 X(001) DV DA CONTA - PREENCHER COM DÍGITO VERIFICADOR DA CONTA*/
                                   'NRODAC'   => array( 'tipo' => 'A', 'ini'  =>  72, 'fim'  =>  72 ),   /*NRODAC   072 072 X(001) DV DA AGÊNCIA/CONTA - PREENCHER COM ESPAÇOS*/
                                   'NOMEMPRE' => array( 'tipo' => 'A', 'ini'  =>  73, 'fim'  => 102 ),   /*NOMEMPRE 073 102 X(030) NOME DA EMPRESA*/
                                   'NOMBANCO' => array( 'tipo' => 'A', 'ini'  => 103, 'fim'  => 132 ),   /*NOMBANCO 103 132 X(030) "CAIXA"*/
                                   'FILLER3'  => array( 'tipo' => 'A', 'ini'  => 133, 'fim'  => 142 ),   /*FILLER3  133 142 X(010) PREENCHER COM ESPAÇOS*/
                                   'CODREMES' => array( 'tipo' => 'N', 'ini'  => 143, 'fim'  => 143 ),   /*CODREMES 143 143 9(001) CÓDIGO DE REMESSA/RETORNO - PREENCHER "1"*/
                                   'DATGERAC' => array( 'tipo' => 'N', 'ini'  => 144, 'fim'  => 151 ),   /*DATGERAC 144 151 9(008) DATA GERAÇÃO DO ARQUIVO - PREENCHER DDMMAA, ESTA DATA DEVERÁ SER SEMPRE A DO MOVIMENTO OU DE DIAS POSTERIORES AO MOVIMENTO, NÃO SENDO ACEITO DATA VENCIDA, NEM DATAS NÃO ÚTEIS*/
                                   'HORGERAC' => array( 'tipo' => 'N', 'ini'  => 152, 'fim'  => 157 ),   /*HORGERAC 152 157 9(006) PREENCHER COM HHMMSS (HORA, MINUTOS E SEGUNDOS)*/
                                   'NSA'      => array( 'tipo' => 'N', 'ini'  => 158, 'fim'  => 163 ),   /*NSA      158 163 9(006) º DEVERÁ SER SEQUENCIAL, EVOLUIR DE 1 EM 1 NO MÍNIMO, PARA CADA ARQUIVO GERADO E TERÁ UMA SEQUÊNCIA PARA O BANCO E OUTRO PARA A EMPRESA*/
                                   'VERLEIAU' => array( 'tipo' => 'N', 'ini'  => 164, 'fim'  => 166 ),   /*VERLEIAU 164 166 9(003) VERSÃO LEIAUTE DO ARQUIVO - PREENCHER "080"*/
                                   'DENGRAVA' => array( 'tipo' => 'N', 'ini'  => 167, 'fim'  => 171 ),   /*DENGRAVA 167 171 9(005) DENSIDADE DE GRAVAÇÃO - PREENCHER "01600"*/
                                   'RESERVA1' => array( 'tipo' => 'A', 'ini'  => 172, 'fim'  => 191 ),   /*RESERVA1 172 191 X(020) RESERVADO DO BANCO - PREENCHER COM ESPAÇOS*/
                                   'RESERVA2' => array( 'tipo' => 'A', 'ini'  => 192, 'fim'  => 211 ),   /*RESERVA2 192 211 X(020) RESERVADO DA EMPRESA - ESTA INFORMAÇÃO NÃO SERÁ TRATADA PELO BANCO*/
                                   'FEBRABAN' => array( 'tipo' => 'A', 'ini'  => 212, 'fim'  => 222 ),   /*FEBRABAN 212 222 X(011) USO EXCLUSIVO FEBRABAN - PREENCHER COM ESPAÇOS*/
                                   'IDCOBRAN' => array( 'tipo' => 'A', 'ini'  => 223, 'fim'  => 225 ),   /*IDCOBRAN 223 225 X(003) IDENTIFICADOR DE COBRANÇA - PREENCHER COM ESPAÇOS*/
                                   'VANS'     => array( 'tipo' => 'N', 'ini'  => 226, 'fim'  => 228 ),   /*VANS     226 228 9(003) USO EXCLUSIVO DAS VAN'S - PREENCHER COM ZERO*/
                                   'TIPOSERV' => array( 'tipo' => 'A', 'ini'  => 229, 'fim'  => 230 ),   /*TIPOSERV 229 230 X(002) TIPO DE SERVIÇO - PREENCHER COM ESPAÇOS*/
                                   'OCORRCOB' => array( 'tipo' => 'A', 'ini'  => 231, 'fim'  => 240 ) ); /*OCORRCOB 230 231 X(001) OCORRÊNCIA COBRANÇA SEM PAPEL - PREENCHER COM ESPAÇOS*/
    private $layoutHeaderLote = array(  'CODBANCO' => array( 'tipo' => 'N', 'ini'  =>   1, 'fim'  =>   3 ),   /*CODBANCO 001 003 9(003) CÓDIGO DO BANCO - PREENCHER "104"*/
                                        'CODLOTE'  => array( 'tipo' => 'N', 'ini'  =>   4, 'fim'  =>   7 ),   /*CODLOTE  004 007 9(004) LOTE DE SERVIÇO - ESTE NÚMERO DEVERÁ EVOLUIR DE 1 EM 1 PARA CADA LOTE DE SERVIÇO GERADO E TERÁ UMA SEQUÊNCIA PARA CADA ARQUIVO GERADO*/
                                        'CODREGIS' => array( 'tipo' => 'N', 'ini'  =>   8, 'fim'  =>   8 ),   /*CODREGIS 008 008 9(001) CÓDIGO DO REGISTRO - PREENCHER "1"*/
                                        'TIPOPERA' => array( 'tipo' => 'A', 'ini'  =>   9, 'fim'  =>   9 ),   /*TIPOPERA 009 009 X(001) TIPO DE OPERAÇÃO - "C" = COMPROMISSO DE PAGAMENTO; "D" = COMPROMISSO DE RECEBIMENTO*/
                                        'TIPSERVI' => array( 'tipo' => 'N', 'ini'  =>  10, 'fim'  =>  11 ),   /*TIPSERVI 010 011 9(002) TIPO DE SERVIÇO - NOTA 2 - "30" = PAGAMENMTO SALARIOS*/
                                        'FORLANCA' => array( 'tipo' => 'N', 'ini'  =>  12, 'fim'  =>  13 ),   /*FORLANCA 012 013 9(002) FORMA DE LANÇAMENTO - NOTA 3 - "01" = CRÉDITO EM CONTA CORRENTE*/
                                        'LAYOUTVE' => array( 'tipo' => 'N', 'ini'  =>  14, 'fim'  =>  16 ),   /*LAYOUTVE 014 016 9(003) VERSÃO DO LEIAUTE DO LOTE - PREENCHER "041"*/
                                        'FILLER1'  => array( 'tipo' => 'A', 'ini'  =>  17, 'fim'  =>  17 ),   /*FILLER1  017 017 X(001) PREENCHER COM ESPAÇOS*/
                                        'TIPOINCR' => array( 'tipo' => 'N', 'ini'  =>  18, 'fim'  =>  18 ),   /*TIPOINCR 018 018 9(001) TIPO DE INSCRIÇÃO - 1- CPF (pessoa física) / 2- CNPJ (pessoa jurídica)*/
                                        'NROINSCR' => array( 'tipo' => 'N', 'ini'  =>  19, 'fim'  =>  32 ),   /*NROINSCR 019 032 9(014) NÚMERO DE INSCRIÇÃO - NOTA 1*/
                                        'CODCONVE' => array( 'tipo' => 'N', 'ini'  =>  33, 'fim'  =>  38 ),   /*CODCONVE 033 038 9(006) CÓDIGO CONVÊNIO NO BANCO - PREENCHER COM CÓDIGO DO CONVÊNIO INFORMADO PELO BANCO*/
                                        'TIPOCOMP' => array( 'tipo' => 'N', 'ini'  =>  39, 'fim'  =>  40 ),   /*TIPOCOMP 039 040 9(002) TIPO DE COMPROMISSO - "02" = PAGAMENTO DE SALÁRIOS*/
                                        'CODCOMPR' => array( 'tipo' => 'N', 'ini'  =>  41, 'fim'  =>  44 ),   /*CODCOMPR 041 044 9(004) CÓDIGO DE COMPROMISSO - PREENCHER COM CÓDIGO DE COMPROMISSO INFORMADO PELO BANCO*/
                                        'PARAMTRA' => array( 'tipo' => 'A', 'ini'  =>  45, 'fim'  =>  46 ),   /*PARAMTRA 045 046 X(002) PARÂMETRO DE TRANSMISSÃO - PARÂMETRO DE TRANSMISSÃO - PREENCHER COM CÓDIGO INFORMADO PELO BANCO*/
                                        'FILLER2'  => array( 'tipo' => 'A', 'ini'  =>  47, 'fim'  =>  52 ),   /*FILLER2  047 052 X(006) FILLER - PREENCHER COM ESPAÇOS*/
                                        'NROAGENC' => array( 'tipo' => 'N', 'ini'  =>  53, 'fim'  =>  58 ),   /*NROAGENC 053 057 9(005) 058 058 X(001) AGÊNCIA DA CONTA CORRENTE - PREENCHER COM CÓDIGO DA AGÊNCIA DETENTORA DA CONTA CORRENTE DA EMPRESA  &  DV DA AGÊNCIA - PREENCHER COM DÍGITO VERIFICADOR DA AGÊNCIA DETENTORA DA CONTA CORRENTE*/
                                                                                                              /*DV DA AGÊNCIA*/
                                        'NROCONTA' => array( 'tipo' => 'A', 'ini'  =>  59, 'fim'  =>  71 ),   /*NROCONTA 059 070 9(012) 071 071 X(001) NÚMERO DA CONTA CORRENTE - DE: 059 A 062 - A OPERAÇÃO DA CONTA DE: 063 A 070 - NÚMERO DA CONTA CORRENTE  &  DV DA CONTA CORRENTE - PREENCHER COM DÍGITO VERIFICADOR DA CONTA*/
                                                                                                              /*DV DA CONTA CORRENTE*/
                                        'NRODAC'   => array( 'tipo' => 'A', 'ini'  =>  72, 'fim'  =>  72 ),   /*NRODAC   072 072 X(001) DIGITO DA AGÊNCIA/CONTA - PREENCHER COM ESPAÇOS*/
                                        'NOMEMPRE' => array( 'tipo' => 'A', 'ini'  =>  73, 'fim'  => 102 ),   /*NOMEMPRE 073 102 X(030) NOME DA EMPRESA*/
                                        'MSGAVIS1' => array( 'tipo' => 'A', 'ini'  => 103, 'fim'  => 142 ),   /*MSGAVIS1 103 142 X(040) MENSAGEM DE AVISO 1 - QUANDO INFORMADA CONSTARÁ EM TODOS OS AVISOS E/OU DOCUMENTOS ORIGINADOS DOS DETALHES DESSE LOTE*/
                                        'LOGRADOU' => array( 'tipo' => 'A', 'ini'  => 143, 'fim'  => 172 ),   /*LOGRADOU 143 172 X(030) LOGRADOURO - PREENCHER COM O NOME DA RUA, AVENIDA, ALAMEDA*/
                                        'NROEMPRE' => array( 'tipo' => 'N', 'ini'  => 173, 'fim'  => 177 ),   /*NROEMPRE 173 177 9(005) PREENCHER COM NÚMERO DO ENDEREÇO*/
                                        'COMEMPRE' => array( 'tipo' => 'A', 'ini'  => 178, 'fim'  => 192 ),   /*COMEMPRE 178 192 X(015) COMPLEMENTO - PREENCHER COM COMPLEMENTO DO ENDEREÇO*/
                                        'MUNEMPRE' => array( 'tipo' => 'A', 'ini'  => 193, 'fim'  => 212 ),   /*MUNEMPRE 193 212 X(020) CIDADE - PREENCHER COM A CIDADE DO ENDEREÇO*/
                                        'CEPEMPRE' => array( 'tipo' => 'A', 'ini'  => 213, 'fim'  => 220 ),   /*CEPEMPRE 213 217 9(005) 218 220 X(003) CEP*/
                                                                                                              /*COMPLEMENTO CEP*/
                                        'ESTEMPRE' => array( 'tipo' => 'A', 'ini'  => 221, 'fim'  => 222 ),   /*ESTEMPRE 221 222 X(002) SIGLA DO ESTADO - PREENCHER CÓDIGO DA UF*/
                                        'FEBRABAN' => array( 'tipo' => 'A', 'ini'  => 223, 'fim'  => 230 ),   /*FEBRABAN 223 230 X(008) USO EXCLUSIVO FEBRABAN - PREENCHER COM ESPAÇOS*/
                                        'OCORRENC' => array( 'tipo' => 'A', 'ini'  => 231, 'fim'  => 240 ));  /*OCORRENC 231 240 X(010) OCORRÊNCIAS - PREENCHER COM ESPAÇOS*/
     private $layoutBodyA = array(  
                                    'CODBANCO' => array( 'tipo' => 'N', 'ini'  =>   1, 'fim'  =>   3 ),    /*CODBANCO 001 003 9(03) CÓDIGO DO BANCO - PREENCHER "104"*/
                                    'CODLOTE'  => array( 'tipo' => 'N', 'ini'  =>   4, 'fim'  =>   7 ),    /*CODLOTE  004 007 9(004) LOTE DE SERVIÇO - ESTE NÚMERO DEVERÁ SER O MESMO DO "HEADER" DE LOTE */
                                    'CODREGIS' => array( 'tipo' => 'N', 'ini'  =>   8, 'fim'  =>   8 ),    /*CODREGIS 008 008 9(001) CÓDIGO DO REGISTRO - PREENCHER "3" */
                                    'NROREGIS' => array( 'tipo' => 'N', 'ini'  =>   9, 'fim'  =>  13 ),    /*NROREGIS 009 013 9(005) NSR - ESTE NÚMERO DEVERÁ EVOLUIR DE 1 EM 1 PARA CADA REGISTRO DO LOTE DE SERVIÇO*/
                                    'CODSEGME' => array( 'tipo' => 'A', 'ini'  =>  14, 'fim'  =>  14 ),    /*CODSEGME 014 014 X(001) CÓDIGO SEGMENTO - PREENCHER "A"*/
                                    'TIPOMOVIMENTO'  => array( 'tipo' => 'A', 'ini'  =>  15, 'fim'  =>  15 ),    /*TIPOMOVIMENTO  015 015 9(001) - Tipo de movimento 0 – inclusão*/
                                    'CODINSTR' => array( 'tipo' => 'N', 'ini'  =>  16, 'fim'  =>  17 ),    /*CODINSTR 016 017 9(002) Código Instrução Movimento 00*/
                                    'CAMCOMP' => array( 'tipo' => 'N', 'ini'  =>  18, 'fim'  =>  20 ),    /*CAMCOMP 019 020 9(003) Câmara compensação 018*/
                                    'CDBANCODEST' => array( 'tipo' => 'N', 'ini'  =>  21, 'fim'  =>  23 ),    /*CDBANCODEST 021 023 9(003) Código Banco Destino*/
                                    'CDAGENCDEST' => array( 'tipo' => 'N', 'ini'  =>  24, 'fim'  =>  42 ),    /*CDBANCODEST 021 023 9(003) Código Banco Destino*/
                                    'DVAGENCDEST' => array( 'tipo' => 'A', 'ini'  =>  43, 'fim'  =>  43 ),    /*DV Agência/Conta Destino*/
                                    'NMVINCULOM' => array( 'tipo' => 'A', 'ini'  => 44, 'fim'  => 73 ),    /*NMVINCULOM 044 073 X(030) Nome do Terceiro (favorecido)*/
                                    'NRVINCULOM' => array( 'tipo' => 'N', 'ini'  => 74, 'fim'  => 79),   /*NRDOCUM 074 079 9(006) Número Documento atribuído pela Empresa*/
                                    'FILLER1'  => array( 'tipo' => 'A', 'ini'  =>  80, 'fim'  =>  92 ),   /*FILLER1  080 092 X(013) PREENCHER COM ESPAÇOS*/
                                    'TPCONTTED'  => array( 'tipo' => 'A', 'ini'  =>  93, 'fim'  =>  93 ),   /*TPCONTTED  093 093 X(001) Tipo de conta – Finalidade TED*/
                                    'DTVENCIM' => array( 'tipo' => 'D', 'ini'  => 94, 'fim'  => 101),   /*DTVENCIM 094 101 9(008) DATA DO VENCIMENTO - A DATA DE VENCIMENTO DO AGENDAMENTO PARA PARCELA ÚNICA OU COM DATA DE VENCIMENTO DA PRIMEIRA PARCELA, PARA AGENDAMENTOS PARCELADOS*/
                                    'TIPOMOE' => array( 'tipo' => 'N', 'ini'  =>  102, 'fim'  =>  104 ),     /*TIPOMOE 102 104 X(003) Tipo da moeda*/
                                    'TOTALMOE' => array( 'tipo' => 'N', 'ini'  =>  105, 'fim'  =>  119 ),     /*TOTALMOE 105 119 9(010)V99999  SOMATÓRIO QTDE DE MOEDA - SOMA DOS VALORES PREVISTOS PARA SEREM EFETIVADOS EM OUTRA MOEDAS*/
                                    'VREVENTOFOLHA' => array( 'tipo' => 'N', 'ini'  =>  120, 'fim'  =>  134 ),     /*TOTALVAL 024 041 9(013)V99  SOMATÓRIA DOS VALORES - SOMA DOS VALORES PREVISTOS PAA SEREM EFETIVADOS EM REAL*/    
                                    'NRDOCUMBANC' => array( 'tipo' => 'N', 'ini'  => 135, 'fim'  => 143),   /*NRDOCUM 135 143 9(009) Número Documento Banco PREENCHER COM 0*/
                                    'FILLER2'  => array( 'tipo' => 'A', 'ini'  =>  144, 'fim'  =>  146 ),   /*FILLER1  144 146 X(003) PREENCHER COM ESPAÇOS*/
                                    'QTPARCELA'  => array( 'tipo' => 'A', 'ini'  =>  147, 'fim'  =>  148 ),   /*QTPARCELA  147 148 9(002) PREENCHER COM 01*/
                                    'INDBLOQUEIO'  => array( 'tipo' => 'A', 'ini'  =>  149, 'fim'  =>  149),   /*INDBLOQUEIO  149 149 X(001)  PREENCHER COM N*/
                                    'FORMPARC' => array( 'tipo' => 'N', 'ini'  => 150, 'fim'  => 150),   /*9(001) Indicador forma parcelamento*/
                                    'DIAVENCIM' => array( 'tipo' => 'N', 'ini'  => 151, 'fim'  => 152),   /*DTVENCIM 151 152 X(002)  DIAVENCIM - A DATA DE VENCIMENTO DO AGENDAMENTO PARA PARCELA ÚNICA OU COM DATA DE VENCIMENTO DA PRIMEIRA PARCELA, PARA AGENDAMENTOS PARCELADOS*/
                                    'NRPARCELA'  => array( 'tipo' => 'N', 'ini'  =>  153, 'fim'  => 154),   /*NRPARCELA  153 154 9(002)  PREENCHER COM NR PARCELA*/
                                    'DTEFETIVACAO' => array( 'tipo' => 'N', 'ini'  => 155, 'fim' => 162),   /*DTEFETIVACAO 155 162 9(008) Data da Efetivação*/
                                    'TOTALVALEFETIV' => array('tipo' => 'N', 'ini'  =>  163, 'fim' => 177),     /*TOTALVAL 163 177 9(013)V99  SOMATÓRIA DOS VALORES - SOMA DOS VALORES PREVISTOS PAA SEREM EFETIVADOS EM REAL*/    
                                    'INFO2' => array( 'tipo' => 'A', 'ini'  =>  178, 'fim'  =>  217),     /*INFO2 178 217 X(040) preencher com espaços*/    
                                    'FINDOC' => array( 'tipo' => 'N', 'ini'  =>  218, 'fim'  =>  219),     /*FINDOC 178 217 9(002)  00*/    
                                    'FEBRABAN' => array( 'tipo' => 'A', 'ini'  => 220, 'fim'  => 229),   /*FEBRABAN 226 240 X(015) USO DA FEBRABAN - PREENCHER COM ESPAÇOS*/
                                    'AVISO' => array( 'tipo' => 'A', 'ini'  => 230, 'fim'  => 230),   /*Aviso ao Favorecido*/
                                    'OCORRENCIASA' => array( 'tipo' => 'A', 'ini'  => 231, 'fim'  => 240));   /*Ocorrencias ao Favorecido*/
                                    
    private $layoutBodyB = array(       'CODBANCO' => array( 'tipo' => 'N', 'ini'  =>   1, 'fim'  =>   3 ),    /*CODBANCO 001 003 9(03) CÓDIGO DO BANCO - PREENCHER "104"*/
                                        'CODLOTE'  => array( 'tipo' => 'N', 'ini'  =>   4, 'fim'  =>   7 ),    /*CODLOTE  004 007 9(004) LOTE DE SERVIÇO - ESTE NÚMERO DEVERÁ SER O MESMO DO "HEADER" DE LOTE */
                                        'CODREGIS' => array( 'tipo' => 'N', 'ini'  =>   8, 'fim'  =>   8 ),    /*CODREGIS 008 008 9(001) CÓDIGO DO REGISTRO - PREENCHER "3" */
                                        'NROREGIS' => array( 'tipo' => 'N', 'ini'  =>   9, 'fim'  =>  13 ),    /*NROREGIS 009 013 9(005) NSR - ESTE NÚMERO DEVERÁ EVOLUIR DE 1 EM 1 PARA CADA REGISTRO DO LOTE DE SERVIÇO*/
                                        'CODSEGME' => array( 'tipo' => 'A', 'ini'  =>  14, 'fim'  =>  14 ),    /*CODSEGME 014 014 X(001) CÓDIGO SEGMENTO - PREENCHER "B"*/
                                        'FILLER1'  => array( 'tipo' => 'A', 'ini'  =>  15, 'fim'  =>  17 ),    /*FILLER1  015 017 X(003) USO FEBRABAN - PREENCHER COM ESPAÇOS*/
                                        'TIPOINCR' => array( 'tipo' => 'N', 'ini'  =>  18, 'fim'  =>  18 ),    /*TIPOINCR 018 018 9(001) TIPO INSCRIÇÃO - 1- CPF (pessoa física) / 2- CNPJ (pessoa jurídica)*/
                                        'NROINSCR' => array( 'tipo' => 'N', 'ini'  =>  19, 'fim'  =>  32 ),    /*NROINSCR 019 032 9(014) NÚMERO DE INSCRIÇÃO - PREENCHER COM NÚMERO DE CPF OU CNPJ DE ACORDO COM O ESCOLHIDO*/
                                        'LOGRADOU' => array( 'tipo' => 'A', 'ini'  =>  33, 'fim'  =>  62 ),    /*LOGRADOU 033 062 X(030) LOGRADOURO - NOME DA RUA, AVENIDA OU ALAMEDA*/
                                        'NRENDERE' => array( 'tipo' => 'N', 'ini'  =>  63, 'fim'  =>  67 ),    /*NRENDERE 063 067 9(005) NÚMERO NO LOCAL - NÚMERO DO ENDEREÇO*/
                                        'COMPLEME' => array( 'tipo' => 'A', 'ini'  =>  68, 'fim'  =>  82 ),    /*COMPLEME 068 082 X(015) COMPLEMENTO - COMPLEMENTO DO ENDEREÇO*/
                                        'BAIRRO'   => array( 'tipo' => 'A', 'ini'  =>  83, 'fim'  =>  97 ),    /*BAIRRO   083 097 X(015) BAIRRO - BAIRRO DO ENDEREÇO*/
                                        'CIDADE'   => array( 'tipo' => 'A', 'ini'  =>  98, 'fim'  => 117 ),    /*CIDADE   098 117 X(020) CIDADE - CIDADE DO ENDEREÇO*/
                                        'CEP'      => array( 'tipo' => 'N', 'ini'  => 118, 'fim'  => 125 ),    /*CEP      118 125 9(008) 118 122 9(005) 123 125 X(003) CEP - CÓDIGO DE ENDEREÇAMENTO POSTAL & COMPLEMENTO DO CÓDIGO DE ENDEREÇAMENTO POSTAL*/
                                                                                                               /*123 125 X(003) COMPLEMENTO CEP*/
                                        'UF'       => array( 'tipo' => 'N', 'ini'  => 126, 'fim'  => 127 ),    /*UF       126 127 X(002) UF DO ESTADO - CÓDIGO DA UF*/
                                        'DTVENCIM' => array( 'tipo' => 'D'/*'ini'  => 127, 'fim'  => 135*/),   /*DTVENCIM 128 135 9(008) DATA DO VENCIMENTO - A DATA DE VENCIMENTO DO AGENDAMENTO PARA PARCELA ÚNICA OU COM DATA DE VENCIMENTO DA PRIMEIRA PARCELA, PARA AGENDAMENTOS PARCELADOS*/
                                        'VRDOCUMEB' => array( 'tipo' => 'N', 'ini'  => 136, 'fim'  => 150 ),    /*VRDOCUME 136 150 9(013)V99 VALOR DO DOCUMENTO - PREENCHER COM ZEROS*/
                                        'VRABATIM' => array( 'tipo' => 'N', 'ini'  => 151, 'fim'  => 165 ),    /*VRABATIM 151 165 9(013)V99 VALOR DO ABATIMENTO - PREENCHER COM ZEROS*/
                                        'VRDESCON' => array( 'tipo' => 'N', 'ini'  => 166, 'fim'  => 180 ),    /*VRDESCON 166 180 9(013)V99 VALOR DO DESCONTO - PREENCHER COM ZEROS*/
                                        'VRMORA'   => array( 'tipo' => 'N', 'ini'  => 181, 'fim'  => 195 ),    /*VRMORA   181 195 9(013)V99 VALOR DA MORA - PREENCHER COM ZEROS*/
                                        'VRMULTA'  => array( 'tipo' => 'N', 'ini'  => 196, 'fim'  => 210 ),    /*VRMULTA  196 210 9(013)V99 VALOR DA MULTA - PREENCHER COM ZEROS*/
                                        'CDDOCUME' => array( 'tipo' => 'A', 'ini'  => 211, 'fim'  => 225 ),    /*CDDOCUME 211 225 X(015) CÓD. DOCUMENTO FAVORECIDO - PREENCHER COM ESPAÇOS. QUANDO O CAMPO 1.06 FOR "10 - OP, PREENCHER COM Nº DO FAVORECIDO. NOS DEMAIS CASOS, PREENCHER COM ESPAÇOS*/
                                        'FEBRABAN' => array( 'tipo' => 'A', 'ini'  => 226, 'fim'  => 240 ));   /*FEBRABAN 226 240 X(015) USO DA FEBRABAN - PREENCHER COM ESPAÇOS*/
    private $layoutTrailerLote = array (    'CODBANCO' => array( 'tipo' => 'N', 'ini'  =>   1, 'fim'  =>   3 ),     /*CODBANCO 001 003 9(003) 104 PREENCHER "104"*/
                                            'CODLOTE'  => array( 'tipo' => 'N', 'ini'  =>   4, 'fim'  =>   7 ),     /*CODLOTE  004 007 9(004) LOTE DE SERVIÇO - Nº DEVERÁ SER O MESMO DO HEADER DE LOTE*/
                                            'CODREGIS' => array( 'tipo' => 'N', 'ini'  =>   8, 'fim'  =>   8 ),     /*CODREGIS 008 008 9(001) CÓDIGO DO REGISTRO - PREENCHER "5"*/
                                            'BRANCOS1' => array( 'tipo' => 'A', 'ini'  =>   9, 'fim'  =>  17 ),     /*BRANCOS1 009 017 X(009) USO EXCLUSIVO FEBRABAN - PREENCHER COM ESPAÇOS*/
                                            'TOTALREG' => array( 'tipo' => 'N', 'ini'  =>  18, 'fim'  =>  23 ),     /*TOTALREG 018 023 9(006) QUANTIDADE DE REGISTROS NO LOTE - QTDE DE REGISTROS DENTRO DO LOTE, CONSIDERAR INCLUSIVE HEADER E TRAILLER DE LOTE*/
                                            'TOTALVAL' => array( 'tipo' => 'N', 'ini'  =>  24, 'fim'  =>  41 ),     /*TOTALVAL 024 041 9(016)V9(2) SOMATÓRIA DOS VALORES - SOMA DOS VALORES PREVISTOS PAA SEREM EFETIVADOS EM REAL*/
                                            'TOTALMOE' => array( 'tipo' => 'N', 'ini'  =>  42, 'fim'  =>  59 ),     /*TOTALMOE 042 059 9(013) SOMATÓRIO QTDE DE MOEDA - SOMA DOS VALORES PREVISTOS PARA SEREM EFETIVADOS EM OUTRA MOEDAS*/
                                            'ZEROS1'   => array( 'tipo' => 'N', 'ini'  =>  60, 'fim'  =>  65 ),     /*ZEROS1   060 065 9(006) Nº AVISO DÉBITO - PREENCHER COM ZEROS*/
                                            'BRANCOS2' => array( 'tipo' => 'A', 'ini'  =>  66, 'fim'  => 230 ),     /*BRANCOS2 066 230 X(165) USO EXCLUSIVO FEBRABAN 2 - PREENCHER COM ESPAÇOS*/
                                            'OCORRENC' => array( 'tipo' => 'A', 'ini'  => 231, 'fim'  => 240 ));    /*OCORRENC 231 240 X(010) OCORRÊNCIAS - PREENCHER COM ESPAÇOS*/
    private $layoutTrailer = array( 'CODBANCO' => array( 'tipo' => 'N', 'ini' =>   1, 'fim' =>   3 ),   /*CODBANCO 001 003 9(003) CÓDIGO DO BANCO - PREENCHER "104"*/
                                    'CODLOTE'  => array( 'tipo' => 'N', 'ini' =>   4, 'fim' =>   7 ),   /*CODLOTE  004 007 9(004) LOTE DE SERVIÇO - PREENCHER "9999"*/
                                    'TIPREGIS' => array( 'tipo' => 'N', 'ini' =>   8, 'fim' =>   8 ),   /*TIPREGIS 008 008 9(001) CÓDIGO DO REGISTRO - PREENCHER "9"*/
                                    'BRANCOS1' => array( 'tipo' => 'A', 'ini' =>   9, 'fim' =>  17 ),   /*BRANCOS1 009 017 X(009) USO EXCLUSIVO FEBRABAN - PREENCHER COM ESPAÇOS*/
                                    'QDELOTES' => array( 'tipo' => 'N', 'ini' =>  18, 'fim' =>  23 ),   /*QDELOTES 018 023 9(006) QUANTIDADE LOTES NO ARQUIVO - QUANTIDADE DE LOTES DENTRO DO ARQUIVO*/
                                    'QDEREGIS' => array( 'tipo' => 'N', 'ini' =>  24, 'fim' =>  29 ),   /*QDEREGIS 024 029 9(006) QUANTIDADE DE REGISTROS DO ARQUIVO - QTDE DE REGISTROS DENTRO DO ARQUIVO, INCLUINDO O HEADER E TRAILLER DE LOTE E DO ARQUIVO*/
                                    'QDECONTA' => array( 'tipo' => 'N', 'ini' =>  30, 'fim' =>  35 ),
                                    'BRANCOS2' => array( 'tipo' => 'A', 'ini' =>  36, 'fim' => 240 ) ); /*BRANCOS2 060 240 X(181) USO EXCLUSIVO FEBRABAN - PREENCHER COM ESPAÇOS*/

    /**
     * Construtor. Adquiri os dados do formulário para as consultas
     * @param $params
     */
    public function __construct($entityManager, $hcmParameters, $connection,  $params){
        
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->nmformcnab    = $params['NMFORMCNAB'];    
        $this->nrForm       = $params['NRFORMCNAB'];    //Carrega os dados do formulário e ambiente
        $this->nrOrg        = $params['NRORG'];
        $this->nrEvento     = $params['NREVENTOM'];
        $this->competencia  = FPA::getDtCompetencia();
        $this->tpMovimento  = $params['NRTIPOMOVIMENT'];
        $this->modalidCalc  = FPA::getNrModalidadeCalculo();
        $this->ocorrenCalc  = FPA::getOcorrenciaCalculo();
        $this->ordem        = $params['DSORDEM'];
        $this->dsIni        = $params['DSINICIO'];
        $this->dsFim        = $params['DSFIM'];
        $this->tpVinculo    = $params['DSTIPOVINCULO'];
        $this->tpInscr      = $params['IDTPINSCRESPONS'];
        $this->nrEstrutResp = $params['NRESTRUTRESPONS'];
        $this->idGeraMagnet = $params['IDGERAMEIOMAG'];
        $this->cdBanco      = $params['CDBANCO'];
        $this->idTeste      = $params['IDTESTE'] == 'N' ? 'P' : 'T'; /*AMBCLIEN 041 041 X(001) AMBIENTE CLIENTE - "T" = TESTE / "P"= PRODUÇÃO*/
        $this->cdConvenio   = $params['CODCONVENIO'];
        $this->cdOperador   = FPA::getCdOperador();
        $this->idLayout   = $params['IDLAYOUT'];

        $this->dtPagamento  = $params['DTPAGAMENTO'];
        $this->idUtilDtPgtoItem = $params['IDUTILDTPGTOITEM'];
        $this->idIgnoraOcorrencia = $params['IDIGNORAOCORRENCIA'];
        $this->_idDtGerUltCnab = $params['IDDTGERULTCNAB'];
        $this->_idIgnoraOcorrencia = $params['IDIGNORAOCORRENCIA'];
        $this->_somenteAnalitico = isset($params['SOMENTEANALITICO']) ? $params['SOMENTEANALITICO'] : false;

       //$this->idatualizacad = $params['IDATUALIZACAD'] == 'S' ? 7 : 1; //1 pagamento a empregados; 7 abertura de cadastro

        $this->nrSequencial = -1;    //Número sequencial, pula as 2 primeiras linhas para funcionar no detalhe
        $this->vrTotal      = 0;    //Valor total dos registros

        //Query do header (arquivo)
            /*CODBANCO 001 003 9(003) 104*/
            /*CODLOTE  004 007 9(004) 0000*/
            /*CODREGIS 008 008 9(001) 0*/
            /*FILLER1  009 017 X(009) ESPAÇOS*/
            /*TIPOINCR 018 018 9(001) 1 = CPF 2 = CNPJ*/
            /*NROINSCR 019 032 9(014) NOTA 1 INSCRIÇÃO NÚMERO: CNPJ EMPRESA DEBITADA*/
            /*CODCONVE 033 038 9(006) 039 040 9(002) CÓD. DO CONVÊNIO INFORMADO PELO BANCO  &  PARÂMETRO DE TRANSMISSÃO - CÓD. INFORMADO PELO BANCO*/
            /*AMBCLIEN 041 041 X(001) AMBIENTE CLIENTE - "T" = TESTE / "P"= PRODUÇÃO*/
            /*AMBCAIXA 042 042 X(001) AMBIENTE CAIXA - PREENCHER COM ESPAÇOS*/
            /*ORIGAPLI 043 045 X(003) ORIGEM APLICATIVO - PREENCHER COM ESPAÇOS*/
            /*NRVERSAO 046 049 9(004) NÚMERO DE VERSÃO - PREENCHER COM ZEROS*/
            /*FILLER2  050 052 X(003) FILLER - PREENCHER COM ESPAÇOS*/
            /*NROAGENC 053 057 9(005) AGÊNCIA DA CONTA CORRENTE - 058 058 9(001) DV DA AGÊNCIA*/
            /*NROCONTA 059 070 9(012) NÚMERO DA CONTA CORRENTE - 071 071 X(001) DV DA CONTA*/
            /*NRODAC   072 072 X(001) DV DA AGÊNCIA/CONTA - PREENCHER COM ESPAÇOS*/
            /*NOMEMPRE 073 102 X(030) NOME DA EMPRESA*/
            /*NOMBANCO 103 132 X(030) "CAIXA"*/
            /*FILLER3  133 142 X(010) PREENCHER COM ESPAÇOS*/
            /*CODREMES 143 143 9(001) CÓDIGO DE REMESSA/RETORNO - PREENCHER "1"*/
            /*DATGERAC 144 151 9(008) DATA GERAÇÃO DO ARQUIVO - PREENCHER DDMMAA, ESTA DATA DEVERÁ SER SEMPRE A DO MOVIMENTO OU DE DIAS POSTERIORES AO MOVIMENTO, NÃO SENDO ACEITO DATA VENCIDA, NEM DATAS NÃO ÚTEIS*/
            /*HORGERAC 152 157 9(006) PREENCHER COM HHMMSS (HORA, MINUTOS E SEGUNDOS)*/
            /*NSA      158 163 9(006) º DEVERÁ SER SEQUENCIAL, EVOLUIR DE 1 EM 1 NO MÍNIMO, PARA CADA ARQUIVO GERADO E TERÁ UMA SEQUÊNCIA PARA O BANCO E OUTRO PARA A EMPRESA*/
            /*VERLEIAU 164 166 9(003) VERSÃO LEIAUTE DO ARQUIVO - PREENCHER "080"*/
            /*DENGRAVA 167 171 9(005) DENSIDADE DE GRAVAÇÃO - PREENCHER "01600"*/
            /*RESERVA1 172 191 X(020) RESERVADO DO BANCO - PREENCHER COM ESPAÇOS*/
            /*RESERVA2 192 211 X(020) RESERVADO DA EMPRESA - ESTA INFORMAÇÃO NÃO SERÁ TRATADA PELO BANCO*/
            /*FEBRABAN 212 222 X(011) USO EXCLUSIVO FEBRABAN - PREENCHER COM ESPAÇOS*/
            /*IDCOBRAN 223 225 X(003) IDENTIFICADOR DE COBRANÇA - PREENCHER COM ESPAÇOS*/
            /*VANS     226 228 9(003) USO EXCLUSIVO DAS VAN'S - PREENCHER COM ZERO*/
            /*TIPOSERV 229 230 X(002) TIPO DE SERVIÇO - PREENCHER COM ESPAÇOS*/
            /*OCORRCOB 230 231 X(001) OCORRÊNCIA COBRANÇA SEM PAPEL - PREENCHER COM ESPAÇOS*/
        $this->queryHeader = <<<SQL
/*Header do Arquivo*/
SELECT                                                   
  DECODE(EHL.CDCNPJESTRUT,
    NULL, DECODE(EHL.CDCPFESTRUTURA,
      NULL, NULL, 1), 2)                       TIPOINCR, 
  NVL(EHL.CDCNPJESTRUT, EHL.CDCNPJESTRUT)      NROINSCR, 
  CC.CDAGENCIA                                 NROAGENC, 
  SUBSTR(LPAD(CC.CDCONTCORR, 13, '0'), 1, 13)  NROCONTA, 
  EHL.NMRAZSOCESTRUT                           NOMEMPRE, 
  TO_CHAR(SYSDATE, 'DDMMYYYY')                 DATGERAC, 
  TO_CHAR(SYSDATE, 'HH24MISS')                 HORGERAC  
FROM ESTRUTURAM EML
JOIN ESTRUTURAH EHL ON EHL.NRORG        = EML.NRORG
                   AND EHL.NRESTRUTURAM = EML.NRESTRUTURAM
                   AND EHL.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                              WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                AND NRORG        = EML.NRORG
                                                AND NRESTRUTURAM = EML.NRESTRUTURAM )
/*conta corrente e banco da estrutura legal*/
JOIN CONTCORRPARC CC ON CC.NRORG          = EML.NRORG
                    AND CC.NRPARCNEGOCIO  = EML.NRPARCNEGOCIO
                    AND CC.IDATIVO        = 'S'
                    AND CC.CDBANCO        = '104' /*Caix Econômica Federal*/
					AND CC.NRCONTCORRPARC = ( SELECT MAX(NRCONTCORRPARC) FROM CONTCORRPARC
					                          WHERE NRORG         = CC.NRORG
											    AND IDATIVO       = CC.IDATIVO
												AND CDBANCO       = CC.CDBANCO
												AND NRPARCNEGOCIO = CC.NRPARCNEGOCIO
												AND NRTPCONTCORR  = CC.NRTPCONTCORR )
WHERE EML.NRORG        = :P_NRORG
  AND EML.NRESTRUTURAM = :P_ESTRUTURA
SQL;

        $this->queryHeaderParams = array(
            'P_NRORG' => $this->nrOrg,
            'P_ESTRUTURA' => $this->nrEstrutResp,
            'P_COMPETENCIA' => $this->competencia,
        );

        //Query do header Lote
            /*CODBANCO 001 003 9(003) CÓDIGO DO BANCO - PREENCHER "104"*/
            /*CODLOTE  004 007 9(004) LOTE DE SERVIÇO - ESTE NÚMERO DEVERÁ EVOLUIR DE 1 EM 1 PARA CADA LOTE DE SERVIÇO GERADO E TERÁ UMA SEQUÊNCIA PARA CADA ARQUIVO GERADO*/
            /*CODREGIS 008 008 9(001) CÓDIGO DO REGISTRO - PREENCHER "1"*/
            /*TIPOPERA 009 009 X(001) TIPO DE OPERAÇÃO - "C" = COMPROMISSO DE PAGAMENTO; "D" = COMPROMISSO DE RECEBIMENTO*/
            /*TIPSERVI 010 011 9(002) TIPO DE SERVIÇO - NOTA 2 - "30" = PAGAMENMTO SALARIOS*/
            /*FORLANCA 012 013 9(002) FORMA DE LANÇAMENTO - NOTA 3 - "01" = CRÉDITO EM CONTA CORRENTE*/
            /*LAYOUTVE 014 016 9(003) VERSÃO DO LEIAUTE DO LOTE - PREENCHER "041"*/
            /*FILLER1  017 017 X(001) PREENCHER COM ESPAÇOS*/
            /*TIPOINCR 018 018 9(001) TIPO DE INSCRIÇÃO - 1- CPF (pessoa física) / 2- CNPJ (pessoa jurídica)*/
            /*NROINSCR 019 032 9(014) NÚMERO DE INSCRIÇÃO - NOTA 1*/
            /*CODCONVE 033 038 9(006) CÓDIGO CONVÊNIO NO BANCO - PREENCHER COM CÓDIGO DO CONVÊNIO INFORMADO PELO BANCO*/
            /*TIPOCOMP 039 040 9(002) TIPO DE COMPROMISSO - "02" = PAGAMENTO DE SALÁRIOS*/
            /*CODCOMPR 041 044 9(004) 045 046 X(002) CÓDIGO DE COMPROMISSO - PREENCHER COM CÓDIGO DE COMPROMISSO INFORMADO PELO BANCO & PARÂMETRO DE TRANSMISSÃO - PREENCHER COM CÓDIGO INFORMADO PELO BANCO*/
            /*PARÂMETRO DE TRANSMISSÃO*/
            /*FILLER2  047 052 X(006) FILLER - PREENCHER COM ESPAÇOS*/
            /*NROAGENC 053 057 9(005) 058 058 X(001) AGÊNCIA DA CONTA CORRENTE - PREENCHER COM CÓDIGO DA AGÊNCIA DETENTORA DA CONTA CORRENTE DA EMPRESA  &  DV DA AGÊNCIA - PREENCHER COM DÍGITO VERIFICADOR DA AGÊNCIA DETENTORA DA CONTA CORRENTE*/
            /*DV DA AGÊNCIA*/
            /*NROCONTA 059 070 9(012) 071 071 X(001) NÚMERO DA CONTA CORRENTE - DE: 059 A 062 - A OPERAÇÃO DA CONTA DE: 063 A 070 - NÚMERO DA CONTA CORRENTE  &  DV DA CONTA CORRENTE - PREENCHER COM DÍGITO VERIFICADOR DA CONTA*/
            /*DV DA CONTA CORRENTE*/
            /*NRODAC   072 072 X(001) DIGITO DA AGÊNCIA/CONTA - PREENCHER COM ESPAÇOS*/
            /*NOMEMPRE 073 102 X(030) NOME DA EMPRESA*/
            /*MSGAVIS1 103 142 X(040) MENSAGEM DE AVISO 1 - QUANDO INFORMADA CONSTARÁ EM TODOS OS AVISOS E/OU DOCUMENTOS ORIGINADOS DOS DETALHES DESSE LOTE*/
            /*LOGRADOU 143 172 X(030) LOGRADOURO - PREENCHER COM O NOME DA RUA, AVENIDA, ALAMEDA*/
            /*NROEMPRE 173 177 9(005) PREENCHER COM NÚMERO DO ENDEREÇO*/
            /*COMEMPRE 178 192 X(015) COMPLEMENTO - PREENCHER COM COMPLEMENTO DO ENDEREÇO*/
            /*MUNEMPRE 193 212 X(020) CIDADE - PREENCHER COM A CIDADE DO ENDEREÇO*/
            /*CEPEMPRE 213 217 9(005) 218 220 X(003) CEP*/
            /*COMPLEMENTO CEP*/
            /*ESTEMPRE 221 222 X(002) SIGLA DO ESTADO - PREENCHER CÓDIGO DA UF*/
            /*FEBRABAN 223 230 X(008) USO EXCLUSIVO FEBRABAN - PREENCHER COM ESPAÇOS*/
            /*OCORRENC 231 240 X(010) OCORRÊNCIAS - PREENCHER COM ESPAÇOS*/
        $this->queryHeaderLote = <<<SQL
/*Header do Lote*/
SELECT                                                 
  NVL(EHL.CDCNPJESTRUT, EHL.CDCNPJESTRUT)      NROINSCR, 
  CC.CDAGENCIA                                 NROAGENC, 
  SUBSTR(LPAD(CC.CDCONTCORR, 13, '0'), 1, 13)  NROCONTA, 
  /*SUBSTR(CC.CDCONTCORR, -1)                    NRODAC,*/   
  EHL.NMRAZSOCESTRUT                           NOMEMPRE, 
  DECODE(EP.CDLOGRADOURO, NULL, EP.DSENDERECO,
    EP.CDLOGRADOURO || ' ' || EP.DSENDERECO)   LOGRADOU, 
  EP.NRIMOVELENDERECO                          NROEMPRE, 
  EP.DSCOMPLEENDERECO                          COMEMPRE, 
  MU.NMMUNICIPIO                               MUNEMPRE, 
  EP.NRCEPENDERECO                             CEPEMPRE, 
  EP.SGESTADO                                  ESTEMPRE  
FROM ESTRUTURAM EML
JOIN ESTRUTURAH EHL ON EHL.NRORG        = EML.NRORG
                   AND EHL.NRESTRUTURAM = EML.NRESTRUTURAM
                   AND EHL.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                              WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                AND NRORG        = EML.NRORG
                                                AND NRESTRUTURAM = EML.NRESTRUTURAM )
/*conta corrente e banco da estrutura legal*/
JOIN CONTCORRPARC CC ON CC.NRORG          = EML.NRORG
                    AND CC.NRPARCNEGOCIO  = EML.NRPARCNEGOCIO
                    --AND CC.NRTPCONTCORR   = 2 /*1 Conta de Movimentação, 2 CNAB, 3 Conta Salário, 4 Pensão Judicial*/
                    AND CC.IDATIVO        = 'S'
                    AND CC.CDBANCO        = '104'
                    AND CC.NRCONTCORRPARC = ( SELECT MAX(NRCONTCORRPARC) FROM CONTCORRPARC
                                              WHERE NRORG         = CC.NRORG
											    AND IDATIVO       = CC.IDATIVO
                                                AND CDBANCO       = CC.CDBANCO
                                                AND NRPARCNEGOCIO = CC.NRPARCNEGOCIO
												AND NRTPCONTCORR  = CC.NRTPCONTCORR )
/*Endereço da estrutura legal*/
LEFT JOIN ENDERECOPARC EP ON EP.NRORG          = EML.NRORG
                         AND EP.NRPARCNEGOCIO  = EML.NRPARCNEGOCIO /*alterar aqui*/
                         AND EP.CDTIPOENDERECO = 'PRINCIPAL'
LEFT JOIN MUNICIPIO MU ON ( MU.NRORG = EP.NRORG OR MU.NRORG = 0 OR MU.NRORG IS NULL )
                      AND MU.CDPAIS      = EP.CDPAIS
                      AND MU.SGESTADO    = EP.SGESTADO
                      AND MU.CDMUNICIPIO = EP.CDMUNICIPIO
/**/
WHERE EML.NRORG        = :P_NRORG
  AND EML.NRESTRUTURAM = :P_ESTRUTURA
SQL;

        $this->queryHeaderLoteParams = array(
            'P_NRORG' => $this->nrOrg,
            'P_ESTRUTURA' => $this->nrEstrutResp,
            'P_COMPETENCIA' => $this->competencia,
        );

        //Query da remessa (body)
            /*CODBANCO 001 003 9(03) CÓDIGO DO BANCO - PREENCHER "104"*/
            /*CODLOTE  004 007 9(004) LOTE DE SERVIÇO - ESTE NÚMERO DEVERÁ SER O MESMO DO "HEADER" DE LOTE */
            /*CODREGIS 008 008 9(001) CÓDIGO DO REGISTRO - PREENCHER "3" */
            /*NSR      009 013 9(005) NSR - ESTE NÚMERO DEVERÁ EVOLUIR DE 1 EM 1 PARA CADA REGISTRO DO LOTE DE SERVIÇO*/
            /*CODSEGME 014 014 X(001) CÓDIGO SEGMENTO - PREENCHER "B"*/
            /*FILLER1  015 017 X(003) USO FEBRABAN - PREENCHER COM ESPAÇOS*/
            /*TIPOINCR 018 018 9(001) TIPO INSCRIÇÃO - 1- CPF (pessoa física) / 2- CNPJ (pessoa jurídica)*/
            /*NROINSCR 019 032 9(014) NÚMERO DE INSCRIÇÃO - PREENCHER COM NÚMERO DE CPF OU CNPJ DE ACORDO COM O ESCOLHIDO*/
            /*LOGRADOU 033 062 X(030) LOGRADOURO - NOME DA RUA, AVENIDA OU ALAMEDA*/
            /*NRENDERE 063 067 9(005) NÚMERO NO LOCAL - NÚMERO DO ENDEREÇO*/
            /*COMPLEME 068 082 X(015) COMPLEMENTO - COMPLEMENTO DO ENDEREÇO*/
            /*BAIRRO   083 097 X(015) BAIRRO - BAIRRO DO ENDEREÇO*/
            /*CIDADE   098 117 X(020) CIDADE - CIDADE DO ENDEREÇO*/
            /*CEP      118 125 9(008) 118 122 9(005) 123 125 X(003) CEP - CÓDIGO DE ENDEREÇAMENTO POSTAL & COMPLEMENTO DO CÓDIGO DE ENDEREÇAMENTO POSTAL*/
            /*123 125 X(003) COMPLEMENTO CEP*/
            /*UF       126 127 X(002) UF DO ESTADO - CÓDIGO DA UF*/
            /*DTVENCIM 128 135 9(008) DATA DO VENCIMENTO - A DATA DE VENCIMENTO DO AGENDAMENTO PARA PARCELA ÚNICA OU COM DATA DE VENCIMENTO DA PRIMEIRA PARCELA, PARA AGENDAMENTOS PARCELADOS*/
            /*VRDOCUME 136 150 9(013)V99 VALOR DO DOCUMENTO - PREENCHER COM ZEROS*/
            /*VRABATIM 151 165 9(013)V99 VALOR DO ABATIMENTO - PREENCHER COM ZEROS*/
            /*VRDESCON 166 180 9(013)V99 VALOR DO DESCONTO - PREENCHER COM ZEROS*/
            /*VRMORA   181 195 9(013)V99 VALOR DA MORA - PREENCHER COM ZEROS*/
            /*VRMULTA  196 210 9(013)V99 VALOR DA MULTA - PREENCHER COM ZEROS*/
            /*CDDOCUME 211 225 X(015) CÓD. DOCUMENTO FAVORECIDO - PREENCHER COM ESPAÇOS. QUANDO O CAMPO 1.06 FOR "10 - OP, PREENCHER COM Nº DO FAVORECIDO. NOS DEMAIS CASOS, PREENCHER COM ESPAÇOS*/
            /*FEBRABAN 226 240 X(015) USO DA FEBRABAN - PREENCHER COM ESPAÇOS*/
        $queryBodyDtItem = $this->idUtilDtPgtoItem == 'N' ? ' ' : "AND ICF.DTOCORRENCIA = '".$this->dtPagamento."'"; //Filtra data de ocorrência do item de cálculo caso seja necessário
        if ($this->idIgnoraOcorrencia == 'S') {
            $queryBodyOcorrencia = '';
        } else {
            $queryBodyOcorrencia = "AND CF.NROCORRECAL    = $this->ocorrenCalc /*:P_OCORRECAL*/";
        }
        $this->queryBody = <<<SQL
/*Registro Detalhe - Registro B*/
SELECT 
  PEH.NRCPFPESSOA                                             NROINSCR, 
  UPPER(EPP.CDLOGRADOURO)                                            LOGRADOU, 
  EPP.NRIMOVELENDERECO                                        NRENDERE, 
  UPPER(EPP.DSCOMPLEENDERECO)                                        COMPLEME, 
  UPPER(EPP.NMBAIRROENDERECO)                                        BAIRRO,   
  UPPER(MUP.NMMUNICIPIO)                                             CIDADE,   
  EPP.NRCEPENDERECO                                           CEP,      
  EPP.SGESTADO                                                UF,       
  ROUND(ICF.VREVENTOFOLHA * 100)                              VRDOCUME, 
  ICF.DTOCORRENCIA                                            DTOCORRENCIA, 
  ICF.NRCALCULOFOLHA                                          NRCALCULOFOLHA,
  VM.NMVINCULOM NOME, VM.NRVINCULOM VINCULO /*Para os erros*/
FROM GPE_VINCULOM VM
JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                    AND VH.NRVINCULOM = VM.NRVINCULOM
                    AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                              WHERE DTMESCOMPETENC <= '$this->competencia' /*:P_COMPETENCIA*/
                                                AND NRORG      = VH.NRORG
                                                AND NRVINCULOM = VH.NRVINCULOM )
/*Pessoa*/
JOIN GPE_PESSOA PE ON PE.NRORG    = VM.NRORG
                  AND PE.NRPESSOA = VM.NRPESSOA
JOIN GPE_PESSOAH PEH ON PEH.NRORG    = VM.NRORG
                    AND PEH.NRPESSOA = PE.NRPESSOA
                    AND PEH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                               WHERE DTMESCOMPETENC <= '$this->competencia' /*:P_COMPETENCIA*/
                                                 AND NRORG    = PEH.NRORG
                                                 AND NRPESSOA = PEH.NRPESSOA )
/*Endereço Pessoa*/
LEFT JOIN ENDERECOPARC EPP ON EPP.NRORG          = PE.NRORG
						  AND EPP.NRPARCNEGOCIO  = PE.NRPARCNEGOCIO
						  AND EPP.CDTIPOENDERECO = 'PRINCIPAL'
LEFT JOIN MUNICIPIO MUP ON MUP.NRORG IN ( 0, EPP.NRORG, NULL )
					   AND MUP.CDPAIS      = EPP.CDPAIS
					   AND MUP.SGESTADO    = EPP.SGESTADO
					   AND MUP.CDMUNICIPIO = EPP.CDMUNICIPIO
/*conta corrente e banco*/
JOIN CONTCORRPARC CC ON CC.NRORG          = VM.NRORG
                    AND CC.NRPARCNEGOCIO  = PE.NRPARCNEGOCIO
                    --AND CC.NRTPCONTCORR   = 2 /*1 Conta de Movimentação, 2 CNAB, 3 Conta Salário, 4 Pensão Judicial*/
                    AND CC.CDBANCO        = '104'
                    AND CC.IDATIVO        = 'S'
                    AND CC.NRCONTCORRPARC = ( SELECT MAX(NRCONTCORRPARC) FROM CONTCORRPARC
                                              WHERE NRORG         = CC.NRORG
											    AND IDATIVO       = CC.IDATIVO
											    AND CDBANCO       = CC.CDBANCO
											    AND NRPARCNEGOCIO = CC.NRPARCNEGOCIO
											    AND NRTPCONTCORR  = CC.NRTPCONTCORR )
/*Itens de cálculo*/
JOIN FPA_CALCULOFOLHA CF ON CF.NRORG          = VM.NRORG
                        AND CF.NRTIPOMOVIMENT = $this->tpMovimento /*:P_TIPOMOVIMENT*/
                        AND CF.NRTPMODALIDCAL = $this->modalidCalc /*:P_TPMODALIDCAL*/
                        AND CF.DTOCORRENCIA   = '$this->competencia' /*:P_COMPETENCIA*/
                        $queryBodyOcorrencia
JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG          = CF.NRORG
                         AND ICF.NRVINCULOM     = VM.NRVINCULOM
                         AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                         AND ICF.NREVENTOM      = $this->nrEvento /*:P_EVENTO*/
                         AND ICF.VREVENTOFOLHA >= 0.005 /*Apenas eventos não zerados*/
                         AND NOT EXISTS (SELECT * FROM FPA_ITECALCFOLHA ITCA WHERE ITCA.NRVINCULOM = ICF.NRVINCULOM AND ITCA.NRORG = ICF.NRORG AND ITCA.NREVENTOM = '3037' AND ITCA.NRCALCULOFOLHA = ICF.NRCALCULOFOLHA )
                         $queryBodyDtItem
/**/
WHERE VM.NRORG         = $this->nrOrg /*:P_NRORG --19*/
SQL;

        $where = '';     //Query da remessa - Ajusta o complemento do where para filtrar e ordenar
        if($this->tpVinculo != ''){ //Filtra os tipos de vínculos (se necessáio)
            $this->tpVinculo = ','.$this->tpVinculo.','; //Ajsute para a query funcionar
            $where = "\r\n  AND INSTR('$this->tpVinculo', ','||VM.NRTIPOVINCULOM||',' ) > 0";
        }
        
        if($this->_idDtGerUltCnab == 'S') {
            $where .= "\r\n  AND  ICF.DTGERULTCNAB IS NULL";
        }
        
        switch($this->ordem){
            case 'ALFABETICA':
                $where .= "\r\n  AND VM.NMVINCULOM BETWEEN '$this->dsIni' AND '$this->dsFim'\r\nORDER BY VM.NMVINCULOM";
                break;
            case 'MATRICULA':
                $where .= "\r\n  AND VM.CDMATRICULA BETWEEN '$this->dsIni' AND '$this->dsFim'\r\nORDER BY VM.CDMATRICULA";
                break;
            case 'DATA_ADMISSAO':
                $where .= "\r\n  AND VM.DTADMISSAOVINC BETWEEN '$this->dsIni' AND '$this->dsFim'\r\nORDER BY VM.DTADMISSAOVINC";
                break;
            case 'ESTRUTURA':
                if(isset($this->dsIni))
                    $where .= "\r\n  AND VH.NRESTRUTLEGAL = '$this->dsIni'";
                if(isset($this->dsFim))
                    $where .= "\r\n  AND VH.NRESTRUTGEREN = '$this->dsFim'";
                break;
            case 'LISTA_ESTRUTURA':
                if(isset($this->dsIni)) {
                    if(is_array($this->dsIni) && !empty($this->dsIni)){
                        $dsIni = implode(',',$this->dsIni);
                        $where .= "\r\n  AND VH.NRESTRUTLEGAL IN ($dsIni)";
                    }
                }
                if(isset($this->dsFim)) {
                    if(is_array($this->dsFim) && !empty($this->dsFim)){
                        $dsFim = implode(',',$this->dsFim);
                        $where .= "\r\n  AND VH.NRESTRUTGEREN IN ($dsFim)";
                    }
                }
                break;
            case 'LISTA_VINCULO':
                if ($this->dsIni == 'A') {
                    $where .= "\r\n  AND '" . $this->dsIni . "' = 'A'";
                } elseif ($this->dsIni == 'N') {
                    $where .= "\r\n  AND VM.NRVINCULOM = '" . $this->dsIni . "'";
                } else {
                    if(is_array($this->dsIni) && !empty($this->dsIni)){
                        $dsIni = implode(',',$this->dsIni);
                        $where .= "\r\n  AND VM.NRVINCULOM IN ($dsIni)";
                    }else if(!empty($this->dsIni)){
                        $where .= "\r\n  AND VM.NRVINCULOM IN ($this->dsIni)";
                    }
                }
                break;
            case 'LISTA_LOTE':
                if (isset($this->dsIni)) {
                    $dsIni = is_array($this->dsIni) ? implode($this->dsIni, ",") : $this->dsIni;
                    $where .= "\r\n  AND VM.NRVINCULOM IN (SELECT NRVINCULOM FROM FPA_ITEMLOTEVINC WHERE NRORG = $this->nrOrg AND NRLOTEVINC IN ($dsIni))"; 
                }
                break;
            case 'ESTRUTURA_SIND':
                if ($this->dsIni == 'A') {
                    $where .= "\r\n  AND '" . $this->dsIni . "' = 'A'";
                } elseif ($this->dsIni == 'N') {
                    $where .= "\r\n  AND VH.NRESTRUTSIND = '" . $this->dsIni . "'";
                } else {
                    $where .= "\r\n  AND VH.NRESTRUTSIND IN (" . $this->dsIni . ")";
                }
                break;
            case 'LISTA_NRESTRUTSIND':
                if($this->dsIni)
                    $this->dsIni = is_array($this->dsIni) ? implode($this->dsIni, ",") : $this->dsIni;
                    $where .= "\r\n  AND VH.NRESTRUTLEGAL IN (".$this->dsIni.")";
                if(isset($this->dsFim)){
                    $this->dsFim = is_array($this->dsFim) ? implode($this->dsFim, ",") : $this->dsFim;
                    $where .= "\r\n  AND VH.NRESTRUTSIND IN (".$this->dsFim.")";
                }
                break;
            case 'LISTA_TOMADOR':
                if($this->dsIni) {
                    $this->dsIni = is_array($this->dsIni) ? implode($this->dsIni, ",") : $this->dsIni;
                    $where .= "\r\n AND EXISTS (SELECT 1 
    	                FROM HIERARQUIAORG H 
    				   WHERE H.NRORG = 3260
                         AND H.NRESTRUTURAMSUP IN ($this->dsIni)
                         AND H.NRESTRUTURAMREL = VH.NRESTRUTGEREN) 	";
                }
                if($this->dsFim){
                    $this->dsFim = is_array($this->dsFim) ? implode($this->dsFim, ",") : $this->dsFim;
                    $where .= "\r\n  AND VH.NRESTRUTGEREN IN ($this->dsFim)";
                }
                break;
            default:
                throw new \exception("Opção de ordenamento inválida ($this->ordem).");
        }
        
        if($this->idLayout == '02'){
            $where .= "\r\n AND CC.NRTPCONTCORR = 3 \r\n";
        }else {
            $where .= "\r\n AND CC.NRTPCONTCORR in (1,2,4) \r\n";
        }
        
        $this->queryBody .= $where; //Completando a query com o restante do where e do order by
        $this->queryBody = "
            SELECT
                NROINSCR, LOGRADOU, NRENDERE, COMPLEME, BAIRRO, CIDADE, CEP, UF, SUM(VRDOCUME) VRDOCUME, NOME, VINCULO, DTOCORRENCIA, NRCALCULOFOLHA
            FROM ($this->queryBody)
            GROUP BY
                NROINSCR, LOGRADOU, NRENDERE, COMPLEME, BAIRRO, CIDADE, CEP, UF, NOME, VINCULO, DTOCORRENCIA, NRCALCULOFOLHA
                ORDER BY VINCULO";
    
        $this->queryBodyA = 
<<<SQL

 SELECT
  CC.CDBANCO        BANFAVOR, 
  LPAD(CC.CDAGENCIA, 5, '0')
    || ' ' || SUBSTR(LPAD( REPLACE( TRANSLATE( CC.CDCONTCORR, TRANSLATE('0' || CC.CDCONTCORR, '0123456789', '@' ), '@' ), '@', '' ), 13, '0'), 1, 12)
    || '' || SUBSTR(CC.CDCONTCORR, -1)                     CDAGENCDEST, 
  VM.NMVINCULOM     NMVINCULOM, 
  VM.NRVINCULOM    NRVINCULOM, 
  ROUND(ICF.VREVENTOFOLHA * 100)                            VREVENTOFOLHA, 
  VM.NMVINCULOM NOME, VM.NRVINCULOM VINCULO /*Para os erros encontrarem*/
FROM GPE_VINCULOM VM
JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                    AND VH.NRVINCULOM = VM.NRVINCULOM
                    AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                              WHERE DTMESCOMPETENC <= '$this->competencia'
                                                AND NRORG      = VH.NRORG
                                                AND NRVINCULOM = VH.NRVINCULOM )
/*Estrutura Legal*/
JOIN ESTRUTURAM EML ON EML.NRORG        = VM.NRORG
                   AND EML.NRESTRUTURAM = VH.NRESTRUTLEGAL
JOIN ESTRUTURAH EHL ON EHL.NRORG        = VM.NRORG
                   AND EHL.NRESTRUTURAM = EML.NRESTRUTURAM
                   AND EHL.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                              WHERE DTMESCOMPETENC <= '$this->competencia'
                                                AND NRORG        = VM.NRORG
                                                AND NRESTRUTURAM = EML.NRESTRUTURAM )
/*Pessoa*/
JOIN GPE_PESSOA PE ON PE.NRORG    = VM.NRORG
                  AND PE.NRPESSOA = VM.NRPESSOA
JOIN GPE_PESSOAH PH ON PH.NRORG      = VM.NRORG
                    AND PH.NRPESSOA = VM.NRPESSOA
                    AND PH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                              WHERE DTMESCOMPETENC <= '$this->competencia'
                                                AND NRORG      = PH.NRORG
                                                AND NRPESSOA = PH.NRPESSOA )
INNER JOIN CONTCORRPARC CC ON CC.NRORG          = VM.NRORG
                         AND CC.NRPARCNEGOCIO  = PE.NRPARCNEGOCIO
                         AND CC.CDBANCO = '104'
                         AND CC.IDATIVO        = 'S'
						             AND CC.NRCONTCORRPARC = ( SELECT MAX(NRCONTCORRPARC)
                                                   FROM CONTCORRPARC
                                                   WHERE NRORG         = CC.NRORG
                                                     AND IDATIVO       = 'S'
                                                     AND CDBANCO       = '104'
                                                     AND NRPARCNEGOCIO = CC.NRPARCNEGOCIO
													 AND NRTPCONTCORR  = CC.NRTPCONTCORR )
/*Itens de cálculo*/
JOIN FPA_CALCULOFOLHA CF ON CF.NRORG          = VM.NRORG
                        AND CF.NRTIPOMOVIMENT = $this->tpMovimento /*:P_TIPOMOVIMENT*/
                        AND CF.NRTPMODALIDCAL = $this->modalidCalc /*:P_TPMODALIDCAL*/
                        AND CF.DTOCORRENCIA   = '$this->competencia'
                         $queryBodyOcorrencia
JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG          = CF.NRORG
                         AND ICF.NRVINCULOM     = VM.NRVINCULOM
                         AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                         AND ICF.NREVENTOM      = $this->nrEvento 
                         AND ICF.VREVENTOFOLHA >= 0.005
                         AND NOT EXISTS (SELECT 1 FROM FPA_ITECALCFOLHA ITCA WHERE ITCA.NRVINCULOM = ICF.NRVINCULOM AND ITCA.NRORG = ICF.NRORG AND ITCA.NREVENTOM = '3037' AND ITCA.NRCALCULOFOLHA = ICF.NRCALCULOFOLHA )
                         $queryBodyDtItem
WHERE VM.NRORG         = $this->nrOrg
SQL;
        $this->queryBodyA .= $where.' ORDER BY VM.NRVINCULOM';
    }

    /**
     * Verifica se os campos obrigatórios estão preenchidos, caso contrário lança um erro
     * @throws \exception
     */
    private function verificaCamposRequeridos(){
        if($this->ordem == 'ALFABETICA' || $this->ordem == 'MATRICULA')
            $camposReq = array( 'Nº do evento'                      => $this->nrEvento,
                                'Tipo de movimento'                 => $this->tpMovimento,
                                'Ordem'                             => $this->ordem,
                                'Descrição inicial'                 => $this->dsIni,
                                'Descrição final'                   => $this->dsFim,
                                'Estrutura da Pessoa Responsável'   => $this->nrEstrutResp );
        else
            $camposReq = array( 'Nº do evento'                      => $this->nrEvento,
                                'Tipo de movimento'                 => $this->tpMovimento,
                                'Ordem'                             => $this->ordem,
                                'Descrição inicial'                 => $this->dsIni);
        $camposVazio = '';
        foreach($camposReq as $label => $campo ) //Procura campos requeridos não preenchidos
            if($campo == null)
                $camposVazio .= $label."\r\n";
        if($camposVazio != '')
            throw new \exception("Os seguintes campos devem estar preenchidos:\r\n".$camposVazio);
    }
    
    public function remove_utf8_bom($text)
    {
        $bom = pack('H*','EFBBBF');
        $text = preg_replace("/^$bom/", '', $text);
        return $text;
    }
    
    /**
     * Verifica se os dados obrigatórios de resposta da query estão todos preenchidos
     * @param array $resultQuery
     * @throws \exception
     */
    private function verificaResultQuery(array $resultQuery){
        $required = array(  'TIPOINCR' => 'Tipo de inscrição da empresa',
                            'NROINSCR' => 'Incrição (CNPJ/CPF) da empresa',
                            'NROAGENC' => 'Número da agência debitada',
                            'NROCONTA' => 'Número da conta debitada',
                            'NOMEMPRE' => 'Razão social da empresa',
                            'LOGRADOU' => 'Endereço da empresa',
                            'NROEMPRE' => 'Número do endereço da empresa',
                            'MUNEMPRE' => 'Múnicípio (do endereço) da empresa',
                            'CEPEMPRE' => 'CEP da empresa'
                            //'BANFAVOR' => 'Número do banco favorecido',
                            //'AGENCONT' => 'Agência do favorecido',
                            //'NOMFAVOR' => 'Nome do favorecido (vínculo)',
                            //'SEUNUMER' => 'Seu número (número de matrícula do vínculo)'
                            );
        $missing = '';
        $nrvinc = -1;
        $vn = false;            //Flag da quebra de linha do vínculo
        $vr = false;            //Contador/Flag do uso da vírgula
        foreach($resultQuery as $regKey => $regVal){    //Percorre todos os resultados da query
            foreach($regVal as $resKey => $resVal){     //Percorre todos os campos de um registro da query
                if(!isset($resVal) && isset($required[$resKey])){       //Procura resultados vazios e se encontar verifica se o mesmo é requerido
                    if($nrvinc != $resultQuery[$regKey]['VINCULO']){    //Verifica se os erros 'trocaram de vínculo'
                        $nrvinc   = $resultQuery[$regKey]['VINCULO'];   //Impede que a frase acima apareça repetidas vezes para o mesmo vínculo
                        $nmvinc   = $resultQuery[$regKey]['NOME'];      //Nome do vínculo
                        $vr       = false;                              //Reinicia o uso da vírgula
                        if($vn){
                            if(isset($nrvinc))                          //Verifica trata-se do header ou trailer onde não há registros de vínculos
                                $missing .= self::newLine."Vínculo $nrvinc $nmvinc: ";  //Identifica o vínculo em que ocorreu o(s) erro(s)
                            else
                                $missing .= self::newLine;              //Não exibi dados de vínculos, deve tratar-se de dados do header ou trailer
                        } else {
                            if(isset($nrvinc))                          //Verifica trata-se do header ou trailer onde não há registros de vínculos
                                $missing .= "Vínculo $nrvinc  $nmvinc: ";   //Primeira lihna que identifica o vínculo em que ocorreu o(s) erro(s)
                            $vn = true;                                 //Sinaliza que as demais linhas de identificação do vínculo são a 2ª linha em diante
                        }
                    }
                    if($vr){                                            //Verirfica se é o caso de se utilizar a ', '
                        $missing .= ', ';
                    } else {
                        $vr = true;                                     //Sinaliza o uso da vírgula para o próximo caso (vínculo)
                    }
                    $missing .= $required[$resKey];                     //Atualiza a mensagem de erro/campo faltante
                }
            }
        }
        if($missing != '')
            throw new \exception("Os seguintes campos devem estar preenchidos:".self::newLine.$missing);
    }
    /**
     * Adquiri os dados do header do arquivo
     * @return array
     * @throws \exception
     */
    private function getHeaderQueryResult(){
        try{
            return $this->connection->fetchAll($this->queryHeader, $this->queryHeaderParams);
        } catch(\Exception $e) {
            throw new \Exception('Erro na query, parte da remessa, a query usada foi esta: ' . $this->queryHeader . ' (' . $e->getMessage() . ')');
        }
    }

    /**
     * Adquiri os dados fixos, do formulário e computados do cabeçalho do arquivo
     * @return array
     */
    private function getHeaderFixed(){
        $codReg = 3;
        if($this->idLayout == '02'){
            $codReg = 2;
        }
        
        $this->nsa = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'REMESSACNAB', 1, 12, true);
        
        return array(   'CODBANCO' => 104,                  /*CODBANCO 001 003 9(003) 104*/
                        'CODLOTE'  => 0,                    /*CODLOTE  004 007 9(004) 0000*/
                        'CODREGIS' => 0,                    /*CODREGIS 008 008 9(001) 0*/
                        'FILLER1'  => ' ',                  /*FILLER1  009 017 X(009) ESPAÇOS*/
                        'PARAMTRA' => $codReg,                                  /*TIPOINCR 018 018 9(001) 1 = CPF 2 = CNPJ*/
                                                            /*NROINSCR 019 032 9(014) NOTA 1 INSCRIÇÃO NÚMERO: CNPJ EMPRESA DEBITADA*/
                        'CODCONVE' => $this->cdConvenio,    /*CODCONVE 033 038 9(006) 039 040 9(002) CÓD. DO CONVÊNIO INFORMADO PELO BANCO  &  PARÂMETRO DE TRANSMISSÃO - CÓD. INFORMADO PELO BANCO*/
                        'AMBCLIEN' => $this->idTeste,       /*AMBCLIEN 041 041 X(001) AMBIENTE CLIENTE - "T" = TESTE / "P"= PRODUÇÃO*/
                        'AMBCAIXA' => ' ',                  /*AMBCAIXA 042 042 X(001) AMBIENTE CAIXA - PREENCHER COM ESPAÇOS*/
                        'ORIGAPLI' => ' ',                  /*ORIGAPLI 043 045 X(003) ORIGEM APLICATIVO - PREENCHER COM ESPAÇOS*/
                        'NRVERSAO' => 0,                    /*NRVERSAO 046 049 9(004) NÚMERO DE VERSÃO - PREENCHER COM ZEROS*/
                        'FILLER2'  => ' ',                  /*FILLER2  050 052 X(003) FILLER - PREENCHER COM ESPAÇOS*/
                                                            /*NROAGENC 053 057 9(005) AGÊNCIA DA CONTA CORRENTE - 058 058 9(001) DV DA AGÊNCIA*/
                                                            /*NROCONTA 059 070 9(012) NÚMERO DA CONTA CORRENTE - 071 071 X(001) DV DA CONTA*/
                        'NRODAC'   => ' ',                  /*NRODAC   072 072 X(001) DV DA AGÊNCIA/CONTA - PREENCHER COM ESPAÇOS*/
                                                            /*NOMEMPRE 073 102 X(030) NOME DA EMPRESA*/
                        'NOMBANCO' => 'CAIXA',              /*NOMBANCO 103 132 X(030) "CAIXA"*/
                        'FILLER3'  => ' ',                  /*FILLER3  133 142 X(010) PREENCHER COM ESPAÇOS*/
                        'CODREMES' => 1,                    /*CODREMES 143 143 9(001) CÓDIGO DE REMESSA/RETORNO - PREENCHER "1"*/
                        //'DATGERAC' => $this->dtPagamento,   /*DATGERAC 144 151 9(008) DATA GERAÇÃO DO ARQUIVO - PREENCHER DDMMAA, ESTA DATA DEVERÁ SER SEMPRE A DO MOVIMENTO OU DE DIAS POSTERIORES AO MOVIMENTO, NÃO SENDO ACEITO DATA VENCIDA, NEM DATAS NÃO ÚTEIS*/
                                                            /*HORGERAC 152 157 9(006) PREENCHER COM HHMMSS (HORA, MINUTOS E SEGUNDOS)*/
                        'NSA'      => $this->nsa,                    /*NSA      158 163 9(006) º DEVERÁ SER SEQUENCIAL, EVOLUIR DE 1 EM 1 NO MÍNIMO, PARA CADA ARQUIVO GERADO E TERÁ UMA SEQUÊNCIA PARA O BANCO E OUTRO PARA A EMPRESA*/
                        'VERLEIAU' => 80,                   /*VERLEIAU 164 166 9(003) VERSÃO LEIAUTE DO ARQUIVO - PREENCHER "080"*/
                        'DENGRAVA' => 1600,                 /*DENGRAVA 167 171 9(005) DENSIDADE DE GRAVAÇÃO - PREENCHER "01600"*/
                        'RESERVA1' => ' ',                  /*RESERVA1 172 191 X(020) RESERVADO DO BANCO - PREENCHER COM ESPAÇOS*/
                        'RESERVA2' => ' ',                  /*RESERVA2 192 211 X(020) RESERVADO DA EMPRESA - ESTA INFORMAÇÃO NÃO SERÁ TRATADA PELO BANCO*/
                        'FEBRABAN' => ' ',                  /*FEBRABAN 212 222 X(011) USO EXCLUSIVO FEBRABAN - PREENCHER COM ESPAÇOS*/
                        'IDCOBRAN' => ' ',                  /*IDCOBRAN 223 225 X(003) IDENTIFICADOR DE COBRANÇA - PREENCHER COM ESPAÇOS*/
                        'VANS'     => 0,                    /*VANS     226 228 9(003) USO EXCLUSIVO DAS VAN'S - PREENCHER COM ZERO*/
                        'TIPOSERV' => ' ',                  /*TIPOSERV 229 230 X(002) TIPO DE SERVIÇO - PREENCHER COM ESPAÇOS*/
                        'OCORRCOB' => ' ' );                /*OCORRCOB 230 231 X(001) OCORRÊNCIA COBRANÇA SEM PAPEL - PREENCHER COM ESPAÇOS*/
    }

    /**
     * Adquiri os dados do header do lote
     * @return array
     * @throws \exception
     */
    private function getHeaderLoteQueryResult(){
        try{
            return $this->connection->fetchAll($this->queryHeaderLote, $this->queryHeaderLoteParams);
        } catch(\Exception $e) {
            throw new \Exception('Erro na query, parte da remessa, a query usada foi esta: ' . $this->queryHeaderLote . ' (' . $e->getMessage() . ')');
        }
    }


    /**
     * Adquiri os dados fixos, do formulário e computados do cabeçalho do lote
     * @return array
     */
    private function getHeaderLoteFixed(){
        $tipoComp = 1;
        if($this->idLayout == '02'){
            $tipoComp = 2;
        }
        return array(   'CODBANCO' => 104,                              /*CODBANCO 001 003 9(003) CÓDIGO DO BANCO - PREENCHER "104"*/
                        'CODLOTE'  => 1,                                /*CODLOTE  004 007 9(004) LOTE DE SERVIÇO - ESTE NÚMERO DEVERÁ EVOLUIR DE 1 EM 1 PARA CADA LOTE DE SERVIÇO GERADO E TERÁ UMA SEQUÊNCIA PARA CADA ARQUIVO GERADO*/
                        'TIPOINCR' => 2,                                /*TIPOINCR 008 008 9(001) CÓDIGO DO REGISTRO - PREENCHER "1"*/
                        'CODREGIS' => 1,                                /*TIPOINCR 008 008 9(001) CÓDIGO DO REGISTRO - PREENCHER "1"*/
                        'TIPOPERA' => 'C',                              /*TIPOPERA 009 009 X(001) TIPO DE OPERAÇÃO - "C" = COMPROMISSO DE PAGAMENTO; "D" = COMPROMISSO DE RECEBIMENTO*/
                        'TIPSERVI' => 30,                               /*TIPSERVI 010 011 9(002) TIPO DE SERVIÇO - NOTA 2 - "30" = PAGAMENMTO SALARIOS*/
                        'FORLANCA' => 1,                                /*FORLANCA 012 013 9(002) FORMA DE LANÇAMENTO - NOTA 3 - "01" = CRÉDITO EM CONTA CORRENTE*/
                        'LAYOUTVE' => 41,                               /*LAYOUTVE 014 016 9(003) VERSÃO DO LEIAUTE DO LOTE - PREENCHER "041"*/
                        'FILLER1'  => ' ',                              /*FILLER1  017 017 X(001) PREENCHER COM ESPAÇOS*/
                        'CODCONVE' => $this->cdConvenio,                /*CODCONVE 033 038 9(006) CÓDIGO CONVÊNIO NO BANCO - PREENCHER COM CÓDIGO DO CONVÊNIO INFORMADO PELO BANCO*/
                        'TIPOCOMP' => $tipoComp,                                /*TIPOCOMP 039 040 9(002) TIPO DE COMPROMISSO - "02" = PAGAMENTO DE SALÁRIOS*/
                        'CODCOMPR' => substr($this->cdConvenio, 8, 4),  /*CODCOMPR 041 044 9(004) CÓDIGO DE COMPROMISSO - PREENCHER COM CÓDIGO DE COMPROMISSO INFORMADO PELO BANCO*/
                        'PARAMTRA' => substr($this->cdConvenio, 6, 2),  /*PARAMTRA 045 046 X(002) PARÂMETRO DE TRANSMISSÃO - PARÂMETRO DE TRANSMISSÃO - PREENCHER COM CÓDIGO INFORMADO PELO BANCO*/
                        'FILLER2'  => ' ',                              /*FILLER2  047 052 X(006) FILLER - PREENCHER COM ESPAÇOS*/
                        //'OPECONTA' => '0001',                           /*OPECONTA 059 062 9(004) OPERAÇÃO DA CONTA*/
                        'NRODAC'   => ' ',                              /*NRODAC   072 072 X(001) DIGITO DA AGÊNCIA/CONTA - PREENCHER COM ESPAÇOS*/
                        'MSGAVIS1' => ' ',                              /*MSGAVIS1 103 142 X(040) MENSAGEM DE AVISO 1 - QUANDO INFORMADA CONSTARÁ EM TODOS OS AVISOS E/OU DOCUMENTOS ORIGINADOS DOS DETALHES DESSE LOTE*/
                        'HISTORCC' => ' ',                              /*HISTORCC 133 142 X(10) ' ' NOTA 7 HISTÓRICO DE C/C COMPLEMENTO HISTÓRICO C/C DEBITADA*/
                        'FEBRABAN' => ' ',                              /*FEBRABAN 223 230 X(008) USO EXCLUSIVO FEBRABAN - PREENCHER COM ESPAÇOS*/
                        'OCORRENC' => ' ',                              /*OCORRENC 231 240 X(010) OCORRÊNCIAS - PREENCHER COM ESPAÇOS*/
            );
    }

    /**
     * Adquiri os dados da remessa (bodyResult)
     * @return array
     * @throws \exception
     */
    private function getBodyQueryResult(){
        try{
            return $this->connection->fetchAll($this->queryBody);
        } catch(\Exception $e) {
            throw new \Exception('Erro na query, parte da remessa, a query usada foi esta: ' . $this->queryBody . ' (' . $e->getMessage() . ')');
        }
    }
    
    private function getBodyAQueryResult(){
        try{
            return $this->connection->fetchAll($this->queryBodyA);
        } catch(\Exception $e) {
            throw new \Exception('Erro na query, parte da remessa, a query usada foi esta: ' . $this->queryBodyA . ' (' . $e->getMessage() . ')');
        }
    }

    /**
     * Adquiri os dados fixos, do formulário e computados da remessa (body) - Segmento A
     * @return array
     * @throws \Exception
     */
    private function getBodyAFixed(){
        $dtPagamento = substr($this->dtPagamento, 0, 10);
        $dtPagamento = \HCM\Util\DateUtil::getDataDeString($dtPagamento);
        $codReg = 3;
        
        return array(   
        'CODBANCO' => 104,  /*CODBANCO 001 003 9(03) CÓDIGO DO BANCO - PREENCHER "104"*/
        'CODLOTE'  => 1,    /*CODLOTE  004 007 9(004) LOTE DE SERVIÇO - ESTE NÚMERO DEVERÁ SER O MESMO DO "HEADER" DE LOTE */
        'CODREGIS' => $codReg,    /*CODREGIS 008 008 9(001) CÓDIGO DO REGISTRO - PREENCHER "3" */
        //'NSR' => $this->nrSequencial + 1,    //009 013 9(005) NSR - ESTE NÚMERO DEVERÁ EVOLUIR DE 1 EM 1 PARA CADA REGISTRO DO LOTE DE SERVIÇO*/
        'CODSEGME' => 'A',  /*CODSEGME 014 014 X(001) CÓDIGO SEGMENTO - PREENCHER "B"*/
        'TIPOMOVIMENTO'  => 0,    /*TIPOMOVIMENTO  015 015 9(001) - Tipo de movimento 0 – inclusão*/
        'CODINSTR' => 0,    /*CODINSTR 016 017 9(002) Código Instrução Movimento 00*/
        'CAMCOMP' => 700,    /*CAMCOMP 019 020 9(003) Câmara compensação 018*/
        'CDBANCODEST' => 104,    /*CDBANCODEST 021 023 9(003) Código Banco Destino*/
        'DVAGENCDEST'  => ' ',   /*FILLER1  080 092 X(013) PREENCHER COM ESPAÇOS*/
        //'CDAGENCDEST' => ,    /*CDAGENCDEST 024 028 9(005)  Código Agencia Destino*/
        //'NMVINCULOM'       => ,    /*NMVINCULOM 044 073 X(030) Nome do Terceiro (favorecido)*/
        //'NRVINCULOM' => ,   /*NRDOCUM 074 079 9(006) Número Documento atribuído pela Empresa*/
        'FILLER1'  => ' ',   /*FILLER1  080 092 X(013) PREENCHER COM ESPAÇOS*/
        'TPCONTTED'  => 0,   /*TPCONTTED  093 093 X(001) Tipo de conta – Finalidade TED*/
        'DTVENCIM' => $dtPagamento,   /*DTVENCIM 094 101 9(008) DATA DO VENCIMENTO - A DATA DE VENCIMENTO DO AGENDAMENTO PARA PARCELA ÚNICA OU COM DATA DE VENCIMENTO DA PRIMEIRA PARCELA, PARA AGENDAMENTOS PARCELADOS*/
        'TIPOMOE' => 'BRL',     /*TIPOMOE 102 104 X(003) Tipo da moeda*/
        'TOTALMOE' => 0,     /*TOTALMOE 105 119 9(010)V99999  SOMATÓRIO QTDE DE MOEDA - SOMA DOS VALORES PREVISTOS PARA SEREM EFETIVADOS EM OUTRA MOEDAS*/
        //'VREVENFOLHA' => ,     /*TOTALVAL 120 134 9(013)V99  SOMATÓRIA DOS VALORES - SOMA DOS VALORES PREVISTOS PAA SEREM EFETIVADOS EM REAL*/    
        'NRDOCUMBANC' => 0,   /*NRDOCUM 135 143 9(009) Número Documento Banco PREENCHER COM 0*/
        'FILLER2'  => ' ',   /*FILLER1  144 146 X(003) PREENCHER COM ESPAÇOS*/
        'QTPARCELA'  => '01',   /*QTPARCELA  147 148 9(002) PREENCHER COM 01*/
        'INDBLOQUEIO'  => 'N',   /*INDBLOQUEIO  149 149 X(001)  PREENCHER COM N*/
        'FORMPARC'  => '1',   /*INDBLOQUEIO  149 149 X(001)  PREENCHER COM N*/
        'DIAVENCIM' => $dtPagamento->format('d'),   /*DTVENCIM 151 152 X(002)  DIAVENCIM - A DATA DE VENCIMENTO DO AGENDAMENTO PARA PARCELA ÚNICA OU COM DATA DE VENCIMENTO DA PRIMEIRA PARCELA, PARA AGENDAMENTOS PARCELADOS*/
        'NRPARCELA'  => 0,   /*NRPARCELA  153 154 9(002)  PREENCHER COM NR PARCELA*/
        'DTEFETIVACAO' => 0,   /*DTEFETIVACAO 155 162 9(008) Data da Efetivação*/
        'TOTALVALEFETIV' => 0,     /*TOTALVAL 163 177 9(013)V99  SOMATÓRIA DOS VALORES - SOMA DOS VALORES PREVISTOS PAA SEREM EFETIVADOS EM REAL*/    
        'INFO2' => ' ',     /*INFO2 178 217 X(040) preencher com espaços*/    
        'FINDOC' => 0,     /*FINDOC 178 217 9(002)  00*/    
        'FEBRABAN' => ' ',   /*FEBRABAN 226 240 X(015) USO DA FEBRABAN - PREENCHER COM ESPAÇOS*/
        'AVISO' => 0,   /*Aviso ao Favorecido*/
        'OCORRENCIASA' => ' '   /*Ocorrencias ao Favorecido*/
        );
    }

    /**
     * Adquiri os dados fixos, do formulário e computados da remessa (body) - Segmento A
     * @return array
     * @throws \Exception
     */
    private function getBodyFixed(){
        $dtPagamento = substr($this->dtPagamento, 0, 10);
        $dtPagamento = \HCM\Util\DateUtil::getDataDeString($dtPagamento);
        return array(   'CODBANCO' => 104,  /*CODBANCO 001 003 9(03) CÓDIGO DO BANCO - PREENCHER "104"*/
                        'CODLOTE'  => 1,    /*CODLOTE  004 007 9(004) LOTE DE SERVIÇO - ESTE NÚMERO DEVERÁ SER O MESMO DO "HEADER" DE LOTE */
                        'CODREGIS' => 3,    /*CODREGIS 008 008 9(001) CÓDIGO DO REGISTRO - PREENCHER "3" */
                        'TIPOINCR' => 1,    /*TIPOINCR 008 008 9(001) CÓDIGO DO REGISTRO - PREENCHER "1" */
                        /*NSR      009 013 9(005) NSR - ESTE NÚMERO DEVERÁ EVOLUIR DE 1 EM 1 PARA CADA REGISTRO DO LOTE DE SERVIÇO*/
                        'CODSEGME' => 'B',  /*CODSEGME 014 014 X(001) CÓDIGO SEGMENTO - PREENCHER "B"*/
                        'FILLER1'  => ' ',  /*FILLER1  015 017 X(003) USO FEBRABAN - PREENCHER COM ESPAÇOS*/
                        /*TIPOINCR 018 018 9(001) TIPO INSCRIÇÃO - 1- CPF (pessoa física) / 2- CNPJ (pessoa jurídica)*/
                        /*NROINSCR 019 032 9(014) NÚMERO DE INSCRIÇÃO - PREENCHER COM NÚMERO DE CPF OU CNPJ DE ACORDO COM O ESCOLHIDO*/
                        /*LOGRADOU 033 062 X(030) LOGRADOURO - NOME DA RUA, AVENIDA OU ALAMEDA*/
                        /*NRENDERE 063 067 9(005) NÚMERO NO LOCAL - NÚMERO DO ENDEREÇO*/
                        /*COMPLEME 068 082 X(015) COMPLEMENTO - COMPLEMENTO DO ENDEREÇO*/
                        /*BAIRRO   083 097 X(015) BAIRRO - BAIRRO DO ENDEREÇO*/
                        /*CIDADE   098 117 X(020) CIDADE - CIDADE DO ENDEREÇO*/
                        /*CEP      118 125 9(008) 118 122 9(005) 123 125 X(003) CEP - CÓDIGO DE ENDEREÇAMENTO POSTAL & COMPLEMENTO DO CÓDIGO DE ENDEREÇAMENTO POSTAL*/
                        /*123 125 X(003) COMPLEMENTO CEP*/
                        /*UF       126 127 X(002) UF DO ESTADO - CÓDIGO DA UF*/
                        'DTVENCIM' => $dtPagamento,/*DTVENCIM 128 135 9(008) DATA DO VENCIMENTO - A DATA DE VENCIMENTO DO AGENDAMENTO PARA PARCELA ÚNICA OU COM DATA DE VENCIMENTO DA PRIMEIRA PARCELA, PARA AGENDAMENTOS PARCELADOS*/
                        'VRDOCUMEB' => 0,    /*VRDOCUME 136 150 9(013)V99 VALOR DO DOCUMENTO - PREENCHER COM ZEROS*/
                        'VRABATIM' => 0,    /*VRABATIM 151 165 9(013)V99 VALOR DO ABATIMENTO - PREENCHER COM ZEROS*/
                        'VRDESCON' => 0,    /*VRDESCON 166 180 9(013)V99 VALOR DO DESCONTO - PREENCHER COM ZEROS*/
                        'VRMORA'   => 0,    /*VRMORA   181 195 9(013)V99 VALOR DA MORA - PREENCHER COM ZEROS*/
                        'VRMULTA'  => 0,    /*VRMULTA  196 210 9(013)V99 VALOR DA MULTA - PREENCHER COM ZEROS*/
                        'CDDOCUME' => ' ',    /*CDDOCUME 211 225 X(015) CÓD. DOCUMENTO FAVORECIDO - PREENCHER COM ESPAÇOS. QUANDO O CAMPO 1.06 FOR "10 - OP, PREENCHER COM Nº DO FAVORECIDO. NOS DEMAIS CASOS, PREENCHER COM ESPAÇOS*/
                        'FEBRABAN' => ' '); /*FEBRABAN 226 240 X(015) USO DA FEBRABAN - PREENCHER COM ESPAÇOS*/

    }

    /**
     * @return array
     * Array da parte 'fixa' do layout do trailer do lote
     */
    private function getTrailerLoteFixed(){
        return array(   'CODBANCO' => 104,                      /*CODBANCO 001 003 9(003) 104 PREENCHER "104"*/
                        'CODLOTE'  => 1,                        /*CODLOTE  004 007 9(004) LOTE DE SERVIÇO - Nº DEVERÁ SER O MESMO DO HEADER DE LOTE*/
                        'CODREGIS' => 5,                        /*CODREGIS 008 008 9(001) CÓDIGO DO REGISTRO - PREENCHER "5"*/
                        'BRANCOS1' => ' ',                      /*BRANCOS1 009 017 X(009) USO EXCLUSIVO FEBRABAN - PREENCHER COM ESPAÇOS*/
                        'TOTALREG' => $this->nrSequencial + 1,  /*TOTALREG 018 023 9(006) QUANTIDADE DE REGISTROS NO LOTE - QTDE DE REGISTROS DENTRO DO LOTE, CONSIDERAR INCLUSIVE HEADER E TRAILLER DE LOTE*/
                        'TOTALVAL' => $this->vrTotal,           /*TOTALVAL 024 041 9(016)V9(2) SOMATÓRIA DOS VALORES - SOMA DOS VALORES PREVISTOS PAA SEREM EFETIVADOS EM REAL*/
                        'TOTALMOE' => 0,                        /*TOTALMOE 042 059 9(013) SOMATÓRIO QTDE DE MOEDA - SOMA DOS VALORES PREVISTOS PARA SEREM EFETIVADOS EM OUTRA MOEDAS*/
                        'ZEROS1'   => 0,                        /*ZEROS1   060 065 9(006) Nº AVISO DÉBITO - PREENCHER COM ZEROS*/
                        'BRANCOS2' => ' ',                      /*BRANCOS2 066 230 X(165) USO EXCLUSIVO FEBRABAN 2 - PREENCHER COM ESPAÇOS*/
                        'OCORRENC' => ' ');                     /*OCORRENC 231 240 X(010) OCORRÊNCIAS - PREENCHER COM ESPAÇOS*/
    }

    /**
     * @return array
     * Array da parte 'fixa' do layout do trailer do arquivo
     */
    private function getTrailerFixed(){
        return array(   'CODBANCO' => 104,                      /*CODBANCO 001 003 9(003) CÓDIGO DO BANCO - PREENCHER "104"*/
                        'CODLOTE'  => 9999,                     /*CODLOTE  004 007 9(004) LOTE DE SERVIÇO - PREENCHER "9999"*/
                        'TIPREGIS' => 9,                        /*TIPREGIS 008 008 9(001) CÓDIGO DO REGISTRO - PREENCHER "9"*/
                        'BRANCOS1' => ' ',                      /*BRANCOS1 009 017 X(009) USO EXCLUSIVO FEBRABAN - PREENCHER COM ESPAÇOS*/
                        'QDELOTES' => 1,                        /*QDELOTES 018 023 9(006) QUANTIDADE LOTES NO ARQUIVO - QUANTIDADE DE LOTES DENTRO DO ARQUIVO*/
                        'QDEREGIS' => $this->nrSequencial + 2,  /*QDEREGIS 024 029 9(006) QUANTIDADE DE REGISTROS DO ARQUIVO - QTDE DE REGISTROS DENTRO DO ARQUIVO, INCLUINDO O HEADER E TRAILLER DE LOTE E DO ARQUIVO*/
                        'QDECONTA' => 0,                        /*QDECONTA 030 042 9(013) QUANTIADE DE CONTAS PARA CONCILIAÇÃO - PREENCHER COM ZEROS*/
                        'BRANCOS2' => ' ',                      /*BRANCOS2 043 240 X(196) USO EXCLUSIVO FEBRABAN - PREENCHER COM ESPAÇOS*/
            );
    }

    /**
     * Mescla os dados fixos com o resultado da query em um novo array
     * @param array $dadosFixo
     * @param array $dadosResult
     * @return array
     */
    private function mesclaDadosFixoResult($dadosFixo, $dadosResult){
        foreach($dadosResult as $linha => $lixo) {
            foreach ($dadosFixo as $linha2 => $registros) {
                $dadosResult[$linha][$linha2] = $registros;
            }
            $dadosResult[$linha]['NROREGIS'] = $this->nrSequencial++; //Número sequencial do registro, todos os arrays (header, body e trailler) devem ter este campo: NRSEQUREG
        }
        return $dadosResult;
    }

    /**
     * @throws \Exception
     * Adquiri os dados para geração do magnético e do arquivo
     */
    public function gerar(){
        $this->verificaCamposRequeridos();              //Se houver algum campo requerido não preenchido este emitirá uma exceção
        //$this->verificaMagnetico();                     //Retorna uma exceção caso já existam registros no magnético
        
        //Header do arquivo
        $Result = $this->getHeaderQueryResult();    //Adquiri o resultado via query do header
        $Fixo   = $this->getHeaderFixed();          //Adquiri os campos fixos do header
        
        $this->headerResult = $this->mesclaDadosFixoResult($Fixo, $Result);
        $this->verificaResultQuery($Result);        //Verifica/gerar execeção com relatórios de erros
        
        $campo = $this->headerResult[0];            //Obtendo a string de saída de acordo com o layout
        $this->headerString = Util::formataLayoutString($campo, $this->layoutHeader);
        
        //Header do lote
        $Result = $this->getHeaderLoteQueryResult();    //Adquiri o resultado via query do header
        $Fixo   = $this->getHeaderLoteFixed();          //Adquiri os campos fixos do header
        
        $this->headerLoteResult = $this->mesclaDadosFixoResult($Fixo, $Result);
        $this->verificaResultQuery($Result);        //Verifica/gerar execeção com relatórios de erros
        
        $campo = $this->headerLoteResult[0];
        $this->headerLoteString = Util::formataLayoutString($campo, $this->layoutHeaderLote);
        
        //BodyA - Registro Detalhe
        $ResultA = $this->getBodyAQueryResult();      //Adquiri o resultado via query do body (remessa)
        $FixoA   = $this->getBodyAFixed();            //Adquiri os campos fixos do body
        $ResultB = $this->getBodyQueryResult();      //Adquiri o resultado via query do body (remessa)
        $FixoB   = $this->getBodyFixed();            //Adquiri os campos fixos do body
        
        $this->bodyAResult = $this->mesclaDadosFixoResult($FixoA, $ResultA);
        $this->verificaResultQuery($ResultA);        //Verifica/gerar execeção com relatórios de erros
        
        $this->bodyResult = $this->mesclaDadosFixoResult($FixoB, $ResultB);
        $this->verificaResultQuery($ResultB);        //Verifica/gerar execeção com relatórios de erros
        $cont = 1;
        foreach( $this->bodyAResult as $key => $campoA) {     //Obtendo a string de saÍda de acordo com o layout - BODY
            $campoA['NROREGIS'] = $cont;
            $cont++;
            $this->bodyResult[$key]['NROREGIS'] = $cont;
            $cont++;
            $this->bodyAString[] = Util::formataLayoutString($campoA, $this->layoutBodyA);
            $this->vrTotal += (int)$this->bodyResult[$key]['VRDOCUME'];
            $this->bodyAString[] = Util::formataLayoutString($this->bodyResult[$key], $this->layoutBodyB);
        }
        
        //Trailer do Lote
        $Fixo = $this->getTrailerLoteFixed();
        $this->trailerLoteResult = $this->mesclaDadosFixoResult($Fixo, array(null));
        $campo = $this->trailerLoteResult[0];
        $this->trailerLoteString = Util::formataLayoutString($campo, $this->layoutTrailerLote);

        //Trailer do Arquivo
        $Fixo = $this->getTrailerFixed();
        $this->trailerResult = $this->mesclaDadosFixoResult($Fixo, array(null));
        $campo = $this->trailerResult[0];
        $this->trailerString = Util::formataLayoutString($campo, $this->layoutTrailer);
        
        //Persiste no magnético (se for o caso)
        $this->gerarMagnetico();
    }

    public function gerarArquivo($nomeArquivo, $extensao){
        
        $nomeArquivo .= $this->nsa.'.'.(string)$extensao;
        
        $this->headerString = $this->remove_utf8_bom($this->headerString);
        $this->headerLoteString = $this->remove_utf8_bom($this->headerLoteString);
        $this->bodyAString = $this->remove_utf8_bom($this->bodyAString);
        $this->trailerLoteString = $this->remove_utf8_bom($this->trailerLoteString);
        $this->trailerString = $this->remove_utf8_bom($this->trailerString);
        
        FPA::escreveArquivo($nomeArquivo, array($this->headerString, $this->headerLoteString), true);
        FPA::escreveArquivo($nomeArquivo, $this->bodyAString, true);
        //FPA::escreveArquivo($nomeArquivo, $this->bodyString, true);
        FPA::escreveArquivo($nomeArquivo, array($this->trailerLoteString, $this->trailerString), true);
        
        if(!$this->_somenteAnalitico) {
            foreach($this->bodyResult as $key => $body) {
                $this->setDtGerUltCNAB($this->bodyResult[$key]['DTOCORRENCIA'], $this->bodyResult[$key]['VINCULO'], $this->bodyResult[$key]['NRCALCULOFOLHA']);
            }
        }
        
        return array(
            'ARQUIVO' => $nomeArquivo,
            'CALCULO' => null,
            'MENSAGENS' => null,
            'ERRO' => null,
            'ABORT' => null
        );
    }
    
    /**
     * @throws \Exception
     * Verifica se já existem registros no magnético (somente se a gravação do mesmo foi requerida). A verificação é
     * antecipada para evitar processamento (dos results e arrays de string) desnecessário.
     */
    public function verificaMagnetico(){
        if($this->idGeraMagnet == 'S') { //Verifica o magnético somente se a gravação do mesmo foi requerida
            $magnetico = new FpaCnabmagnetEntity($this->entityManager, $this->hcmParameters);
            $mesCompetencia = $this->competencia;
            /*if( !($mesCompetencia instanceof \TkDateTime) )
                $mesCompetencia = new \TkDateTime($mesCompetencia);*/
            $aux = $magnetico->retornaRegistros($mesCompetencia, $this->nrOrg, $this->cdBanco, $this->tpMovimento, $this->cdOperador);
            if ($aux)
                throw new \Exception("Já existem registros no magnético. O CNAB não foi gerado.");
        }
    }
    /**
     * @throws \Exception
     * @throws \TkValidationException
     * Grava dados no magnético somente se estes foram requeridos
     */
    public function gerarMagnetico(){
        if($this->idGeraMagnet == 'S'){ //Grava no magnético somente se o mesmo foi requerido
            $magnetico = new FpaCnabmagnetEntity($this->entityManager, $this->hcmParameters);
            for($i = 0, $n = count($this->bodyResult); $i < $n; ++$i) {
                $magnetico->insereRegistroLista($this->nrOrg, $this->cdOperador, $this->competencia, null, $this->tpInscr,
                    $this->headerResult[0]['NROINSCR'], $this->bodyString[$i], '104', $this->tpMovimento,
                    $this->bodyResult[$i]['NROREGIS'], $this->bodyResult[$i]['VRDOCUME'] / 100,
                    $this->bodyResult[$i]['VINCULO']);
                $magnetico->persist();
            }
        }
    }

    /**
     * Retrocede os registros do magnético
     */
    public function retroceder(){
        $magnetico = new FpaCnabmagnetEntity($this->entityManager, $this->hcmParameters);
        $magnetico->retroceder($this->nrOrg, $this->competencia, $this->cdBanco, $this->tpMovimento, $this->cdOperador);
    }

    /**
     * Retorna um array de array contendo todos os campos de resultado da query
     * @return mixed
     */
    public function getHeaderResult(){
        return $this->headerResult;
    }

    /**
     * Retorna um array de array contendo todos os campos de resultado da query
     * @return mixed
     */
    public function getBodyResult(){
        return $this->bodyResult;
    }

    /**
     * Retorna um array de array contendo todos os campos de resultado da query
     * @return mixed
     */
    public function getTraillerResult(){
        return $this->traillerResult;
    }

    /**
     * Retorna um array contendo a string do header (cabeçalho) formatada para geração do arquivo
     * @return array
     */
    public function getHeaderString(){
        return $this->headerString;
    }

    /**
     * Retorna um array contendo as strings do body (dados de tranferências) formatada para geração do arquivo
     * @return array
     */
    public function getBodyString(){
        return $this->bodyString;
    }

    /**
     * Retorna um array contendo a string do trailler (final do arquivo) formatada para geração do arquivo
     * @return array
     */
    public function getTraillerString(){
        return $this->traillerString;
    }

    public function setDtGerUltCNAB($dtocorrencia, $nrvinculom, $nrcalculofolha){
        $sql = "UPDATE FPA_ITECALCFOLHA 
                    SET DTGERULTCNAB = SYSDATE 
                WHERE 
                    NRORG = :P_NRORG 
                    AND NREVENTOM = :P_NREVENTOM
                    AND NRCALCULOFOLHA = :P_NRCALCULOFOLHA
                    AND NRVINCULOM     = :P_NRVINCULOM
                    AND DTOCORRENCIA   = :P_DTOCORRENCIA
        ";

        $params = array(
            'P_NREVENTOM' => $this->nrEvento,
            'P_NRCALCULOFOLHA' => $nrcalculofolha,
            'P_NRORG' => $this->nrOrg,
            'P_NRVINCULOM' => $nrvinculom,
            'P_DTOCORRENCIA' => $dtocorrencia
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
} 