<?php

namespace HCM\Geral\Repository;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;

class PerfacessparcOperadorRepository {
    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function getMaxNrPerfAcessParc ($nrorg) {
        $sqlSelect = "SELECT MAX(NRPERFACESSPARC) as MAXNRPERFACESSPARC
                        FROM PERFACESSPARC
                       WHERE NRORG = :P_NRORG";

        $params = ['P_NRORG' => $nrorg];
        $bdData = $this->entityManager->getConnection()->fetchAll($sqlSelect, $params);

        if (empty($bdData)) {
            return 1;
        }
        else {
            return $bdData[0]['MAXNRPERFACESSPARC'];
        }
    }

    public function novoPerfacessparcAdmissao($data){
        $nrperfacessparc = \HCM\Util\NovoCodigo::geraCodigo($data['NRORG'], 'PERFACESSPARC', 1, 12, true);

        $perfacessparc = Repositories::PERFACESSPARC;
        $perfacessparc = new $perfacessparc;
        $perfacessparc->setNrperfacessparc($nrperfacessparc);
        $perfacessparc->setNrperfilacesso($data['NRPERFILACESSO']);
        $perfacessparc->setNrparcnegocio($data['NRPARCNEGOCIO']);
        $perfacessparc->setDtvalperfilparc(null);
        $perfacessparc->setIdativo($data['IDATIVO']);
        $perfacessparc->setNrorg($data['NRORG']);
        $perfacessparc->setNrorginclusao($data['NRORG']);
        $perfacessparc->setNrorgultatu($data['NRORG']);
        $perfacessparc->setCdoperinclusao($data['CDOPERINCLUSAO']);
        $perfacessparc->setCdoperultatu($data['CDOPERULTATU']);
        $perfacessparc->setDtinclusao($data['DTINCLUSAO']);
        $perfacessparc->setDtultatu($data['DTULTATU']);

        $this->entityManager->persist($perfacessparc);
        $this->entityManager->flush($perfacessparc);

        unset($perfacessparc);
    }
}