/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PARAMPRODMRP                                             */
/* Tabela : PARAMPRODMRP                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 26/10/2004 - Andr Rodrigo                                                 */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PARAMPRODMRP
BEFORE INSERT OR UPDATE OR DELETE
ON PARAMPRODMRP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPAPM := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (:OLD.CDFILIAL   <> :NEW.CDFILIAL)   OR
         (:OLD.CDPRODUTO  <> :NEW.CDPRODUTO)  OR
         (:OLD.HRENTRPROD <> :NEW.HRENTRPROD) THEN
         :NEW.DTULTATUPAPM := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PARAMPRODMRP', '', 'CDFILIAL='||:OLD.CDFILIAL||';CDPRODUTO='||:OLD.CDPRODUTO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PARAMPRODMRP MODIFY DTULTATUPAPM DEFAULT SYSDATE
/
