/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: 8340_SUPVIE_FORN_REG.SQL                                             */
/*                                                                            */
/* Descrio:                                                                 */
/* Retorna os Fornecedores e as Regies que ele atende.                       */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 28/06/2000 - Alexis Tolentino                                              */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* @H:\SISTEMAS\DBA\SQL\ORACLE\8470_SUPVIE_FORN_REG.SQL                       */
/******************************************************************************/

CREATE OR REPLACE
VIEW FORN_REG AS
SELECT
     FORREG.CDFORNECED,
     FORREG.IDTPIJURFORN,
     FORREG.NRINSJURFORN,
     FORREG.NMRAZSOCFORN,
     FORREG.NMFANTFORN,
     FORREG.IDTPDESCFORN,
     FORREG.VRPEDESCFORN,
     FORREG.IDTPFRETFORN,
     FORREG.CDQUALIF,
     FORREG.IDFORNAUTO,
     FORREG.DTVALQUALIF,
     FORREG.CDREGIAO,
     FORREG.NMREGIAO
   FROM(
   SELECT
     FORNECEDOR.CDFORNECED,
     FORNECEDOR.IDTPIJURFORN,
     FORNECEDOR.NRINSJURFORN,
     FORNECEDOR.NMRAZSOCFORN,
     FORNECEDOR.NMFANTFORN,
     FORNECEDOR.IDTPDESCFORN,
     FORNECEDOR.VRPEDESCFORN,
     FORNECEDOR.IDTPFRETFORN,
     FORNECEDOR.CDQUALIF,
     FORNECEDOR.IDFORNAUTO,
     FORNECEDOR.DTVALQUALIF,
     REGIAO.CDREGIAO,
     REGIAO.NMREGIAO
   FROM
     FORNECEDOR, REGIAO
   WHERE
      FORNECEDOR.IDSITUCADA = 'A') FORREG,
   REFOREG
WHERE
      REFOREG.CDFORNECED(+) = FORREG.CDFORNECED AND
      REFOREG.CDREGIAO(+)   = FORREG.CDREGIAO   AND
      REFOREG.CDFORNECED IS NULL                AND
      REFOREG.CDREGIAO IS NULL
/
